/*!
 * Application Insights JavaScript SDK - Dependencies Plugin, 3.3.6
 * Copyright (c) Microsoft and contributors. All rights reserved.
 */
"use strict";var strShimFunction="function",strShimObject="object",strShimUndefined="undefined",strShimPrototype="prototype",ObjClass$1=Object,ObjProto$1=ObjClass$1[strShimPrototype];function _pureAssign(e,t){return e||t}function _pureRef(e,t){return e[t]}var UNDEF_VALUE=undefined,NULL_VALUE=null,EMPTY="",FUNCTION="function",OBJECT="object",PROTOTYPE="prototype",__PROTO__="__proto__",UNDEFINED="undefined",CONSTRUCTOR="constructor",SYMBOL="Symbol",POLYFILL_TAG="_polyfill",LENGTH="length",NAME="name",CALL="call",TO_STRING="toString",ObjClass=_pureAssign(Object),ObjProto=_pureRef(ObjClass,PROTOTYPE),StrCls=_pureAssign(String),StrProto=_pureRef(StrCls,PROTOTYPE),MathCls=_pureAssign(Math),ArrCls=_pureAssign(Array),ArrProto=_pureRef(ArrCls,PROTOTYPE),ArrSlice=_pureRef(ArrProto,"slice");function safe(e,t){try{return{v:e.apply(this,t)}}catch(n){return{e:n}}}function _createIs(t){return function(e){return typeof e===t}}function _createObjIs(e){var t="[object "+e+"]";return function(e){return!(!e||objToString(e)!==t)}}function objToString(e){return ObjProto[TO_STRING].call(e)}function isUndefined(e){return typeof e===UNDEFINED||e===UNDEFINED}function isStrictUndefined(e){return!isDefined(e)}function isNullOrUndefined(e){return e===NULL_VALUE||isUndefined(e)}function isStrictNullOrUndefined(e){return e===NULL_VALUE||!isDefined(e)}function isDefined(e){return!!e||e!==UNDEF_VALUE}var isString=_createIs("string"),isFunction=_createIs(FUNCTION);function isObject(e){return!(!e&&isNullOrUndefined(e)||!e||typeof e!==OBJECT)}var isArray=_pureRef(ArrCls,"isArray"),isNumber=_createIs("number"),isError=_createObjIs("Error"),objGetOwnPropertyDescriptor=_pureRef(ObjClass,"getOwnPropertyDescriptor");function objHasOwnProperty(e,t){return!!e&&ObjProto.hasOwnProperty[CALL](e,t)}var objHasOwn=_pureAssign(_pureRef(ObjClass,"hasOwn"),polyObjHasOwn);function polyObjHasOwn(e,t){return objHasOwnProperty(e,t)||!!objGetOwnPropertyDescriptor(e,t)}function objForEachKey(e,t,n){if(e&&isObject(e))for(var r in e)if(objHasOwn(e,r)&&-1===t[CALL](n||e,r,e[r]))break}var propMap={e:"enumerable",c:"configurable",v:"value",w:"writable",g:"get",s:"set"};function _createProp(t){var e,n={};return n[propMap.c]=!0,n[propMap.e]=!0,t.l&&(n.get=function(){return t.l.v},(e=objGetOwnPropertyDescriptor(t.l,"v"))&&e.set&&(n.set=function(e){t.l.v=e})),objForEachKey(t,function(e,t){n[propMap[e]]=isStrictUndefined(t)?n[propMap[e]]:t}),n}var objDefineProp=_pureRef(ObjClass,"defineProperty");function objDefine(e,t,n){return objDefineProp(e,t,_createProp(n))}function _createKeyValueMap(e,n,r,t,a){var o={};return objForEachKey(e,function(e,t){_assignMapValue(o,e,n?t:e),_assignMapValue(o,t,r?t:e)}),t?t(o):o}function _assignMapValue(e,t,n,r){objDefineProp(e,t,{value:n,enumerable:!0,writable:!1})}var asString=_pureAssign(StrCls),ERROR_TYPE="[object Error]";function dumpObj(e,t){var n=EMPTY,r=ObjProto[TO_STRING][CALL](e);r===ERROR_TYPE&&(e={stack:asString(e.stack),message:asString(e.message),name:asString(e.name)});try{n=((n=JSON.stringify(e,NULL_VALUE,t?"number"==typeof t?t:4:UNDEF_VALUE))?n.replace(/"(\w+)"\s*:\s{0,1}/g,"$1: "):NULL_VALUE)||asString(e)}catch(a){n=" - "+dumpObj(a,t)}return r+": "+n}function throwError(e){throw Error(e)}function throwTypeError(e){throw new TypeError(e)}var _objFreeze=_pureRef(ObjClass,"freeze");function _doNothing(e){return e}function _getProto(e){return e[__PROTO__]||NULL_VALUE}var objAssign=_pureRef(ObjClass,"assign"),objKeys=_pureRef(ObjClass,"keys"),objFreeze=_pureAssign(_objFreeze,_doNothing),objGetPrototypeOf=_pureAssign(_pureRef(ObjClass,"getPrototypeOf"),_getProto);function createEnumKeyMap(e){return _createKeyValueMap(e,0,0,objFreeze)}function createSimpleMap(e){var n={};return objForEachKey(e,function(e,t){_assignMapValue(n,e,t[1]),_assignMapValue(n,t[0],t[1])}),objFreeze(n)}function createTypeMap(e){return createSimpleMap(e)}var _globalCfg,_wellKnownSymbolMap=createEnumKeyMap({asyncIterator:0,hasInstance:1,isConcatSpreadable:2,iterator:3,match:4,matchAll:5,replace:6,search:7,species:8,split:9,toPrimitive:10,toStringTag:11,unscopables:12}),GLOBAL_CONFIG_KEY="__tsUtils$gblCfg";function _getGlobalValue(){var e;return(e=(e=(e=typeof globalThis!==UNDEFINED?globalThis:e)||typeof self===UNDEFINED?e:self)||typeof window===UNDEFINED?e:window)||typeof global===UNDEFINED?e:global}function _getGlobalConfig(){var e;return _globalCfg||(e=safe(_getGlobalValue).v||{},_globalCfg=e[GLOBAL_CONFIG_KEY]=e[GLOBAL_CONFIG_KEY]||{}),_globalCfg}var _unwrapFunction=_unwrapFunctionWithPoly;function _unwrapFunctionWithPoly(r,e,a){var o=e?e[r]:NULL_VALUE;return function(e){var t,n=(e?e[r]:NULL_VALUE)||o;if(n||a)return t=arguments,(n||a).apply(e,n?ArrSlice[CALL](t,1):t);throwTypeError('"'+asString(r)+'" not defined for '+dumpObj(e))}}var mathMax=_pureRef(MathCls,"max"),strSlice=_unwrapFunctionWithPoly("slice",StrProto),strSubstring=_unwrapFunctionWithPoly("substring",StrProto),strSubstr=_unwrapFunctionWithPoly("substr",StrProto,polyStrSubstr);function polyStrSubstr(e,t,n){return isNullOrUndefined(e)&&throwTypeError("Invalid "+dumpObj(e)),n<0?EMPTY:((t=t||0)<0&&(t=mathMax(t+e[LENGTH],0)),isUndefined(n)?strSlice(e,t):strSlice(e,t,t+n))}function strLeft(e,t){return strSubstring(e,0,t)}var _polySymbols,_wellKnownSymbolCache,_globalLazyTestHooks,UNIQUE_REGISTRY_ID="_urid";function _globalSymbolRegistry(){var e;return _polySymbols||(e=_getGlobalConfig(),_polySymbols=e.gblSym=e.gblSym||{k:{},s:{}}),_polySymbols}function polyNewSymbol(e){var t={description:asString(e),toString:function(){return SYMBOL+"("+e+")"}};return t[POLYFILL_TAG]=!0,t}function polySymbolFor(e){var t,n,r=_globalSymbolRegistry();return objHasOwn(r.k,e)||(t=polyNewSymbol(e),n=objKeys(r.s).length,t[UNIQUE_REGISTRY_ID]=function(){return n+"_"+t[TO_STRING]()},r.k[e]=t,r.s[t[UNIQUE_REGISTRY_ID]()]=asString(e)),r.k[e]}function polyGetKnownSymbol(e){_wellKnownSymbolCache=_wellKnownSymbolCache||{};e=_wellKnownSymbolMap[e];return e?_wellKnownSymbolCache[e]=_wellKnownSymbolCache[e]||polyNewSymbol(SYMBOL+"."+e):void 0}function _initTestHooks(){_globalLazyTestHooks=_getGlobalConfig()}function createCachedValue(e){return objDefineProp({toJSON:function(){return e}},"v",{value:e})}var _cachedGlobal,WINDOW="window";function _getGlobalInstFn(e,t){var n;return function(){return _globalLazyTestHooks||_initTestHooks(),(n=n&&!_globalLazyTestHooks.lzy?n:createCachedValue(safe(e,t).v)).v}}function getGlobal(e){return _globalLazyTestHooks||_initTestHooks(),(_cachedGlobal=_cachedGlobal&&!1!==e&&!_globalLazyTestHooks.lzy?_cachedGlobal:createCachedValue(safe(_getGlobalValue).v||NULL_VALUE)).v}function getInst(e,t){t=_cachedGlobal&&!1!==t?_cachedGlobal.v:getGlobal(t);if(t&&t[e])return t[e];if(e===WINDOW)try{return window}catch(n){}return NULL_VALUE}var getDocument=_getGlobalInstFn(getInst,["document"]);function hasWindow(){return!!getWindow()}var _symbol,_symbolFor,_iterSymbol$1,getWindow=_getGlobalInstFn(getInst,[WINDOW]),getNavigator=_getGlobalInstFn(getInst,["navigator"]),isWebWorker=_getGlobalInstFn(function(){return!!safe(function(){return self&&self instanceof WorkerGlobalScope}).v});function _initSymbol(){return _symbol=createCachedValue(safe(getInst,[SYMBOL]).v)}function _getSymbolKey(e){var t=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return t.v?t.v[e]:UNDEF_VALUE}function getKnownSymbol(e,t){var n=_wellKnownSymbolMap[e],r=(_globalLazyTestHooks||_initTestHooks(),(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol());return r.v?r.v[n||e]:t?UNDEF_VALUE:polyGetKnownSymbol(e)}function newSymbol(e,t){_globalLazyTestHooks||_initTestHooks();var n=(_globalLazyTestHooks.lzy?0:_symbol)||_initSymbol();return n.v?n.v(e):t?NULL_VALUE:polyNewSymbol(e)}function symbolFor(e){return _globalLazyTestHooks||_initTestHooks(),((_symbolFor=(_globalLazyTestHooks.lzy?0:_symbolFor)||createCachedValue(safe(_getSymbolKey,["for"]).v)).v||polySymbolFor)(e)}function isIterator(e){return!!e&&isFunction(e.next)}function isIterable(e){return!isStrictNullOrUndefined(e)&&isFunction(e[getKnownSymbol(3)])}function iterForOf(e,t,n){if(e&&(isIterator(e)||(e=e[(_iterSymbol$1=_iterSymbol$1||createCachedValue(getKnownSymbol(3))).v]?e[_iterSymbol$1.v]():NULL_VALUE),isIterator(e))){var r=UNDEF_VALUE,a=UNDEF_VALUE;try{for(var o=0;!(a=e.next()).done&&-1!==t[CALL](n||e,a.value,o,e);)o++}catch(_){r={e:_},e["throw"]&&(a=NULL_VALUE,e["throw"](r))}finally{try{a&&!a.done&&e["return"]&&e["return"](a)}finally{if(r)throw r.e}}}}function fnApply(e,t,n){return e.apply(t,n)}function arrAppend(t,e){return!isUndefined(e)&&t&&(isArray(e)?fnApply(t.push,t,e):isIterator(e)||isIterable(e)?iterForOf(e,function(e){t.push(e)}):t.push(e)),t}function arrForEach(e,t,n){if(e)for(var r=e[LENGTH]>>>0,a=0;a<r&&!(a in e&&-1===t[CALL](n||e,e[a],a,e));a++);}var _isProtoArray,arrIndexOf=_unwrapFunctionWithPoly("indexOf",ArrProto),objCreate=_pureAssign(_pureRef(ObjClass,"create"),polyObjCreate);function polyObjCreate(e){if(!e)return{};var t=typeof e;function n(){}return t!==OBJECT&&t!==FUNCTION&&throwTypeError("Prototype must be an Object or function: "+dumpObj(e)),n[PROTOTYPE]=e,new n}function objSetPrototypeOf(e,t){return(ObjClass.setPrototypeOf||function(n,e){var t;(_isProtoArray=_isProtoArray||createCachedValue(((t={})[__PROTO__]=[],t instanceof Array))).v?n[__PROTO__]=e:objForEachKey(e,function(e,t){return n[e]=t})})(e,t)}function _createCustomError(e,t,n){function r(){this[CONSTRUCTOR]=t,safe(objDefine,[this,NAME,{v:e,c:!0,e:!1}])}return safe(objDefine,[t,NAME,{v:e,c:!0,e:!1}]),(t=objSetPrototypeOf(t,n))[PROTOTYPE]=n===NULL_VALUE?objCreate(n):(r[PROTOTYPE]=n[PROTOTYPE],new r),t}function _setName(e,t){t&&(e[NAME]=t)}function createCustomError(a,o,e){var _=e||Error,i=_[PROTOTYPE][NAME],s=Error.captureStackTrace;return _createCustomError(a,function(){var e=this,t=arguments;try{safe(_setName,[_,a]);var n,r=fnApply(_,e,ArrSlice[CALL](t))||e;return r!==e&&(n=objGetPrototypeOf(e))!==objGetPrototypeOf(r)&&objSetPrototypeOf(r,n),s&&s(r,e[CONSTRUCTOR]),o&&o(r,t),r}finally{safe(_setName,[_,i])}},_)}function utcNow(){return(Date.now||polyUtcNow)()}function polyUtcNow(){return(new Date).getTime()}function _createTrimFn(t){return function(e){return isNullOrUndefined(e)&&throwTypeError("strTrim called ["+dumpObj(e)+"]"),e&&e.replace?e.replace(t,EMPTY):e}}var _fnToString,_objCtrFnString,_gblWindow,_perf,polyStrTrim=_createTrimFn(/^\s+|(?=\s)\s+$/g),strTrim=_unwrapFunctionWithPoly("trim",StrProto,polyStrTrim),mathFloor=_pureRef(MathCls,"floor");function isPlainObject(e){if(!e||typeof e!==OBJECT)return!1;var t=!1;if(e!==(_gblWindow=_gblWindow||!hasWindow()||getWindow())){_objCtrFnString||(_fnToString=Function[PROTOTYPE][TO_STRING],_objCtrFnString=_fnToString[CALL](ObjClass));try{var n=objGetPrototypeOf(e),t=(t=!n)||!(!(n=objHasOwnProperty(n,CONSTRUCTOR)?n[CONSTRUCTOR]:n)||typeof n!==FUNCTION||_fnToString[CALL](n)!==_objCtrFnString)}catch(r){}}return t}function getPerformance(){return _globalLazyTestHooks||_initTestHooks(),(_perf=_perf&&!_globalLazyTestHooks.lzy?_perf:createCachedValue(safe(getInst,["performance"]).v)).v}var mathRound=_pureRef(MathCls,"round"),strSplit=_unwrapFunctionWithPoly("split",StrProto),strIndexOf=_unwrapFunctionWithPoly("indexOf",StrProto),REF="ref",UNREF="unref",HAS_REF="hasRef",ENABLED="enabled";function _createTimerHandler(e,t,n){var r,a=!0,o=e?t(NULL_VALUE):NULL_VALUE;function _(){return a=!1,o&&o[UNREF]&&o[UNREF](),r}function i(){o&&n(o),o=NULL_VALUE}function s(){return o=t(o),a||_(),r}return(r={cancel:i,refresh:s})[HAS_REF]=function(){return o&&o[HAS_REF]?o[HAS_REF]():a},r[REF]=function(){return a=!0,o&&o[REF]&&o[REF](),r},r[UNREF]=_,{h:r=objDefineProp(r,ENABLED,{get:function(){return!!o},set:function(e){!e&&o&&i(),e&&!o&&s()}}),dn:function(){o=NULL_VALUE}}}function _createTimeoutWith(e,t,n){var r=isArray(t),a=r?t.length:0,o=(0<a?t[0]:r?UNDEF_VALUE:t)||setTimeout,_=(1<a?t[1]:UNDEF_VALUE)||clearTimeout,i=n[0],s=(n[0]=function(){s.dn(),fnApply(i,UNDEF_VALUE,ArrSlice[CALL](arguments))},_createTimerHandler(e,function(e){if(e){if(e.refresh)return e.refresh(),e;fnApply(_,UNDEF_VALUE,[e])}return fnApply(o,UNDEF_VALUE,n)},function(e){fnApply(_,UNDEF_VALUE,[e])}));return s.h}function scheduleTimeout(e,t){return _createTimeoutWith(!0,UNDEF_VALUE,ArrSlice[CALL](arguments))}(getGlobal()||{}).Symbol,(getGlobal()||{}).Reflect;var _a$3,strHasOwnProperty="hasOwnProperty",__objAssignFnImpl=function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var a in t=arguments[n])ObjProto$1[strHasOwnProperty].call(t,a)&&(e[a]=t[a]);return e},__assignFn=objAssign||__objAssignFnImpl,extendStaticsFn=function(e,t){return(extendStaticsFn=ObjClass$1.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t[strHasOwnProperty](n)&&(e[n]=t[n])})(e,t)};function __extendsFn(e,t){function n(){this.constructor=e}typeof t!==strShimFunction&&null!==t&&throwTypeError("Class extends value "+t+" is not a constructor or null"),extendStaticsFn(e,t),e[strShimPrototype]=null===t?objCreate(t):(n[strShimPrototype]=t[strShimPrototype],new n)}var Constructor="constructor",Prototype="prototype",strFunction="function",DynInstFuncTable="_dynInstFuncs",DynProxyTag="_isDynProxy",DynClassName="_dynClass",DynClassNamePrefix="_dynCls$",DynInstChkTag="_dynInstChk",DynAllowInstChkTag=DynInstChkTag,DynProtoDefaultOptions="_dfOpts",UnknownValue="_unknown_",str__Proto="__proto__",DynProtoBaseProto="_dyn"+str__Proto,DynProtoGlobalSettings="__dynProto$Gbl",DynProtoCurrent="_dynInstProto",strUseBaseInst="useBaseInst",strSetInstFuncs="setInstFuncs",Obj=Object,_objGetPrototypeOf=Obj.getPrototypeOf,_objGetOwnProps=Obj.getOwnPropertyNames,_gbl=getGlobal(),_gblInst=_gbl[DynProtoGlobalSettings]||(_gbl[DynProtoGlobalSettings]={o:((_a$3={})[strSetInstFuncs]=!0,_a$3[strUseBaseInst]=!0,_a$3),n:1e3});function _isObjectOrArrayPrototype(e){return e&&(e===Obj[Prototype]||e===Array[Prototype])}function _isObjectArrayOrFunctionPrototype(e){return _isObjectOrArrayPrototype(e)||e===Function[Prototype]}function _getObjProto$1(e){if(e){if(_objGetPrototypeOf)return _objGetPrototypeOf(e);var t=e[str__Proto]||e[Prototype]||(e[Constructor]?e[Constructor][Prototype]:null),n=e[DynProtoBaseProto]||t;objHasOwnProperty(e,DynProtoBaseProto)||(delete e[DynProtoCurrent],n=e[DynProtoBaseProto]=e[DynProtoCurrent]||e[DynProtoBaseProto],e[DynProtoCurrent]=t)}return n}function _forEachProp(e,t){var n=[];if(_objGetOwnProps)n=_objGetOwnProps(e);else for(var r in e)"string"==typeof r&&objHasOwnProperty(e,r)&&n.push(r);if(n&&0<n.length)for(var a=0;a<n.length;a++)t(n[a])}function _isDynamicCandidate(e,t,n){return t!==Constructor&&typeof e[t]===strFunction&&(n||objHasOwnProperty(e,t))&&t!==str__Proto&&t!==Prototype}function _throwTypeError(e){throwTypeError("DynamicProto: "+e)}function _getInstanceFuncs(t){var n=objCreate(null);return _forEachProp(t,function(e){!n[e]&&_isDynamicCandidate(t,e,!1)&&(n[e]=t[e])}),n}function _hasVisited(e,t){for(var n=e.length-1;0<=n;n--)if(e[n]===t)return!0;return!1}function _getBaseFuncs(e,t,n,o){function r(e,t,n){var r,a=t[n];return a[DynProxyTag]&&o&&!1!==(r=e[DynInstFuncTable]||{})[DynAllowInstChkTag]&&(a=(r[t[DynClassName]]||{})[n]||a),function(){return a.apply(e,arguments)}}for(var a=objCreate(null),_=(_forEachProp(n,function(e){a[e]=r(t,n,e)}),_getObjProto$1(e)),i=[];_&&!_isObjectArrayOrFunctionPrototype(_)&&!_hasVisited(i,_);)_forEachProp(_,function(e){!a[e]&&_isDynamicCandidate(_,e,!_objGetPrototypeOf)&&(a[e]=r(t,_,e))}),i.push(_),_=_getObjProto$1(_);return a}function _getInstFunc(e,t,n,r){var a=null;if(e&&objHasOwnProperty(n,DynClassName)){var o=e[DynInstFuncTable]||objCreate(null);if((a=(o[n[DynClassName]]||objCreate(null))[t])||_throwTypeError("Missing ["+t+"] "+strFunction),!a[DynInstChkTag]&&!1!==o[DynAllowInstChkTag]){for(var _=!objHasOwnProperty(e,t),i=_getObjProto$1(e),s=[];_&&i&&!_isObjectArrayOrFunctionPrototype(i)&&!_hasVisited(s,i);){var c=i[t];if(c){_=c===r;break}s.push(i),i=_getObjProto$1(i)}try{_&&(e[t]=a),a[DynInstChkTag]=1}catch(u){o[DynAllowInstChkTag]=!1}}}return a}function _getProtoFunc(e,t,n){var r=t[e];return typeof(r=r===n?_getObjProto$1(t)[e]:r)!==strFunction&&_throwTypeError("["+e+"] is not a "+strFunction),r}function _populatePrototype(a,e,o,_,t){var n,i;_isObjectOrArrayPrototype(a)||_isObjectOrArrayPrototype(n=o[DynInstFuncTable]=o[DynInstFuncTable]||objCreate(null))||(i=n[e]=n[e]||objCreate(null),!1!==n[DynAllowInstChkTag]&&(n[DynAllowInstChkTag]=!!t),_isObjectOrArrayPrototype(i)||_forEachProp(o,function(e){var t,n,r;_isDynamicCandidate(o,e,!1)&&o[e]!==_[e]&&(i[e]=o[e],delete o[e],objHasOwnProperty(a,e)&&(!a[e]||a[e][DynProxyTag])||(a[e]=(t=a,n=e,(r=function(){return(_getInstFunc(this,n,t,r)||_getProtoFunc(n,t,r)).apply(this,arguments)})[DynProxyTag]=1,r)))}))}function _checkPrototype(e,t){if(_objGetPrototypeOf){for(var n=[],r=_getObjProto$1(t);r&&!_isObjectArrayOrFunctionPrototype(r)&&!_hasVisited(n,r);){if(r===e)return!0;n.push(r),r=_getObjProto$1(r)}return!1}return!0}function _getObjName(e,t){return objHasOwnProperty(e,Prototype)?e.name||t||UnknownValue:((e||{})[Constructor]||{}).name||t||UnknownValue}function dynamicProto(e,t,n,r){objHasOwnProperty(e,Prototype)||_throwTypeError("theClass is an invalid class definition.");var a=e[Prototype],o=(_checkPrototype(a,t)||_throwTypeError("["+_getObjName(e)+"] not in hierarchy of ["+_getObjName(t)+"]"),null),e=(objHasOwnProperty(a,DynClassName)?o=a[DynClassName]:(o=DynClassNamePrefix+_getObjName(e,"_")+"$"+_gblInst.n,_gblInst.n++,a[DynClassName]=o),dynamicProto[DynProtoDefaultOptions]),_=!!e[strUseBaseInst],i=(_&&r&&r[strUseBaseInst]!==undefined&&(_=!!r[strUseBaseInst]),_getInstanceFuncs(t)),_=(n(t,_getBaseFuncs(a,t,i,_)),!!_objGetPrototypeOf&&!!e[strSetInstFuncs]);_populatePrototype(a,o,t,i,!1!==(_=_&&r?!!r[strSetInstFuncs]:_))}dynamicProto[DynProtoDefaultOptions]=_gblInst.o;var aggregationErrorType,createValueMap=createTypeMap,_DYN_TO_LOWER_CASE$2="toLowerCase",_DYN_LENGTH$2="length",_DYN_WARN_TO_CONSOLE="warnToConsole",_DYN_THROW_INTERNAL="throwInternal",_DYN_WATCH="watch",_DYN_APPLY="apply",_DYN_PUSH="push",_DYN_SPLICE="splice",_DYN_LOGGER="logger",_DYN_CANCEL="cancel",_DYN_INITIALIZE="initialize",_DYN_IDENTIFIER="identifier",_DYN_IS_INITIALIZED="isInitialized",_DYN_GET_PLUGIN="getPlugin",_DYN_NAME$1="name",_DYN_PROCESS_NEXT="processNext",_DYN_GET_PROCESS_TEL_CONT2="getProcessTelContext",_DYN_UNLOAD="unload",_DYN_VERSION="version",_DYN_LOGGING_LEVEL_CONSOL4="loggingLevelConsole",_DYN_CREATE_NEW="createNew",_DYN_TEARDOWN="teardown",_DYN_MESSAGE_ID="messageId",_DYN_MESSAGE="message",_DYN_DIAG_LOG="diagLog",_DYN__DO_TEARDOWN="_doTeardown",_DYN_UPDATE="update",_DYN_GET_NEXT="getNext",_DYN_SET_NEXT_PLUGIN="setNextPlugin",_DYN_USER_AGENT="userAgent",_DYN_SPLIT$1="split",_DYN_REPLACE="replace",_DYN_TYPE="type",_DYN_IS_CHILD_EVT="isChildEvt",_DYN_GET_CTX="getCtx",_DYN_SET_CTX="setCtx",_DYN_TRACE_FLAGS$1="traceFlags";function throwAggregationError(e,t){aggregationErrorType=aggregationErrorType||createCustomError("AggregationError",function(e,t){1<t[_DYN_LENGTH$2]&&(e.errors=t[1])});var n=e||"One or more errors occurred.";throw arrForEach(t,function(e,t){n+="\n".concat(t," > ").concat(dumpObj(e))}),new aggregationErrorType(n,t||[])}var UNDEFINED_VALUE=undefined,STR_EMPTY="",STR_CORE="core",STR_DISABLED="disabled",STR_EXTENSION_CONFIG="extensionConfig",STR_PROCESS_TELEMETRY="processTelemetry",STR_PRIORITY="priority",STR_GET_PERF_MGR="getPerfMgr",STR_NOT_DYNAMIC_ERROR="Not dynamic - ",strGetPrototypeOf="getPrototypeOf",rCamelCase=/-([a-z])/g,rNormalizeInvalid=/([^\w\d_$])/g,rLeadingNumeric=/^(\d+[\w\d_$])/,_getObjProto=Object[strGetPrototypeOf];function isNotNullOrUndefined(e){return!isNullOrUndefined(e)}function normalizeJsName(e){return e&&isString(e)?(e=(e=e[_DYN_REPLACE](rCamelCase,function(e,t){return t.toUpperCase()}))[_DYN_REPLACE](rNormalizeInvalid,"_"))[_DYN_REPLACE](rLeadingNumeric,function(e,t){return"_"+t}):e}function strContains(e,t){return!(!e||!t)&&-1!==strIndexOf(e,t)}function toISOString(e){return e&&e.toISOString()||""}function getExceptionName(e){return isError(e)?e[_DYN_NAME$1]:STR_EMPTY}function _createProxyFunction(e,t){var n=null,r=null;return isFunction(e)?n=e:r=e,function(){var e=arguments;if(r=n?n():r)return r[t][_DYN_APPLY](r,e)}}function proxyFunctionAs(e,t,n,r,a){e&&t&&n&&(!1===a&&!isUndefined(e[t])||(e[t]=_createProxyFunction(n,r)))}function createClassFromInterface(e){return function(){var n=this;e&&objForEachKey(e,function(e,t){n[e]=t})}}var strDocumentMode="documentMode",strLocation="location",strConsole="console",strJSON="JSON",strCrypto="crypto",strMsCrypto="msCrypto",strMsie="msie",strTrident="trident/",strXMLHttpRequest="XMLHttpRequest",_isTrident=null,_navUserAgentCheck=null,_enableMocks=!1;function getLocation(e){if(e&&_enableMocks){e=getInst("__mockLocation");if(e)return e}return typeof location===strShimObject&&location?location:getInst(strLocation)}function getConsole(){return typeof console!==strShimUndefined?console:getInst(strConsole)}function hasJSON(){return!!(typeof JSON===strShimObject&&JSON||null!==getInst(strJSON))}function getJSON(){return hasJSON()?JSON||getInst(strJSON):null}function getCrypto(){return getInst(strCrypto)}function getMsCrypto(){return getInst(strMsCrypto)}function isIE(){var e=getNavigator();return!e||e[_DYN_USER_AGENT]===_navUserAgentCheck&&null!==_isTrident||(e=((_navUserAgentCheck=e[_DYN_USER_AGENT])||STR_EMPTY)[_DYN_TO_LOWER_CASE$2](),_isTrident=strContains(e,strMsie)||strContains(e,strTrident)),_isTrident}function getIEVersion(e){var t=((e=(e=void 0===e?null:e)?e:(t=getNavigator()||{})?(t.userAgent||STR_EMPTY)[_DYN_TO_LOWER_CASE$2]():STR_EMPTY)||STR_EMPTY)[_DYN_TO_LOWER_CASE$2]();if(strContains(t,strMsie))return e=getDocument()||{},mathMax(parseInt(t[_DYN_SPLIT$1](strMsie)[1]),e[strDocumentMode]||0);if(strContains(t,strTrident)){e=parseInt(t[_DYN_SPLIT$1](strTrident)[1]);if(e)return e+4}return null}function isXhrSupported(){var e=!1;try{e=!!getInst(strXMLHttpRequest)}catch(t){}return e}var UInt32Mask=4294967296,MaxUInt32=4294967295,SEED1=123456789,SEED2=987654321,_mwcSeeded=!1,_mwcW=SEED1,_mwcZ=SEED2;function _mwcSeed(e){e<0&&(e>>>=0),_mwcW=SEED1+e&MaxUInt32,_mwcZ=SEED2-e&MaxUInt32,_mwcSeeded=!0}function _autoSeedMwc(){try{var e=2147483647&utcNow();_mwcSeed((Math.random()*UInt32Mask^e)+e)}catch(t){}}function random32(e){var t=0,n=getCrypto()||getMsCrypto();return 0===(t=n&&n.getRandomValues?n.getRandomValues(new Uint32Array(1))[0]&MaxUInt32:t)&&isIE()&&(_mwcSeeded||_autoSeedMwc(),t=mwcRandom32()&MaxUInt32),0===t&&(t=mathFloor(UInt32Mask*Math.random()|0)),e||(t>>>=0),t}function mwcRandom32(e){var t=((_mwcZ=36969*(65535&_mwcZ)+(_mwcZ>>16)&MaxUInt32)<<16)+(65535&(_mwcW=18e3*(65535&_mwcW)+(_mwcW>>16)&MaxUInt32))>>>0&MaxUInt32|0;return e||(t>>>=0),t}function newId(e){void 0===e&&(e=22);for(var t=random32()>>>0,n=0,r=STR_EMPTY;r[_DYN_LENGTH$2]<e;)r+="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"[0|63&t]||"",t>>>=6,5==++n&&(t=(random32()<<2&4294967295|3&t)>>>0,n=0);return r}var version="3.3.6",instanceName="."+newId(6),_dataUid=0;function _canAcceptData(e){return 1===e.nodeType||9===e.nodeType||!+e.nodeType}function _getCache(e,t){var n=t[e.id];if(!n){n={};try{_canAcceptData(t)&&objDefine(t,e.id,{e:!1,v:n})}catch(r){}}return n}function createUniqueNamespace(e,t){return normalizeJsName(e+_dataUid+++((t=void 0!==t&&t)?"."+version:STR_EMPTY)+instanceName)}function createElmNodeData(e){var o={id:createUniqueNamespace("_aiData-"+(e||STR_EMPTY)+"."+version),accept:function(e){return _canAcceptData(e)},get:function(e,t,n,r){var a=e[o.id];return a?a[normalizeJsName(t)]:(r&&((a=_getCache(o,e))[normalizeJsName(t)]=n),n)},kill:function(e,t){if(e&&e[t])try{delete e[t]}catch(n){}}};return o}function _isConfigDefaults(e){return e&&isObject(e)&&(e.isVal||e.fb||objHasOwn(e,"v")||objHasOwn(e,"mrg")||objHasOwn(e,"ref")||e.set)}function _getDefault(e,t,n){var r,a=n.dfVal||isDefined;if(t&&n.fb){var o=n.fb;isArray(o)||(o=[o]);for(var _=0;_<o[_DYN_LENGTH$2];_++){var i=o[_],s=t[i];if(a(s)?r=s:e&&(a(s=e.cfg[i])&&(r=s),e.set(e.cfg,asString(i),s)),a(r))break}}return!a(r)&&a(n.v)?n.v:r}function _resolveDefaultValue(n,r,e){var a,t=e;return(t=e&&_isConfigDefaults(e)?_getDefault(n,r,e):t)&&(_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),isArray(t)?(a=[])[_DYN_LENGTH$2]=t[_DYN_LENGTH$2]:isPlainObject(t)&&(a={}),a&&(objForEachKey(t,function(e,t){t&&_isConfigDefaults(t)&&(t=_resolveDefaultValue(n,r,t)),a[e]=t}),t=a)),t}function _applyDefaultValue(n,e,t,r){var a,o,_,i,s,c,u=r,u=_isConfigDefaults(u)?(a=u.isVal,o=u.set,s=u.rdOnly,l=u.blkVal,_=u.mrg,!(i=u.ref)&&isUndefined(i)&&(i=!!_),_getDefault(n,e,u)):r,r=(l&&n.blkVal(e,t),!0),l=e[t];!l&&isNullOrUndefined(l)||(c=l,r=!1,a&&c!==u&&!a(c)&&(c=u,r=!0),o&&(r=(c=o(c,u,e))===u)),r?c=u&&_resolveDefaultValue(n,e,u):(isPlainObject(c)||isArray(u))&&_&&u&&(isPlainObject(u)||isArray(u))&&objForEachKey(u,function(e,t){_applyDefaultValue(n,c,e,t)}),n.set(e,t,c),i&&n.ref(e,t),s&&n.rdOnly(e,t)}var CFG_HANDLER_LINK=symbolFor("[[ai_dynCfg_1]]"),BLOCK_DYNAMIC=symbolFor("[[ai_blkDynCfg_1]]"),FORCE_DYNAMIC=symbolFor("[[ai_frcDynCfg_1]]");function _cfgDeepCopy(e){var n;return e&&(isArray(e)?(n=[])[_DYN_LENGTH$2]=e[_DYN_LENGTH$2]:isPlainObject(e)&&(n={}),n)?(objForEachKey(e,function(e,t){n[e]=_cfgDeepCopy(t)}),n):e}function getDynamicConfigHandler(e){if(e){var t=e[CFG_HANDLER_LINK]||e;if(t.cfg&&(t.cfg===e||t.cfg[CFG_HANDLER_LINK]===t))return t}return null}function blockDynamicConversion(e){if(e&&(isPlainObject(e)||isArray(e)))try{e[BLOCK_DYNAMIC]=!0}catch(t){}return e}function _canMakeDynamic(e,t,n){var r=!1;return!n||e[t.blkVal]||(r=n[FORCE_DYNAMIC])||n[BLOCK_DYNAMIC]?r:isPlainObject(n)||isArray(n)}function throwInvalidAccess(e){throwTypeError("InvalidAccess:"+e)}var arrayMethodsToPatch=["push","pop","shift","unshift","splice"],_throwDynamicError=function(e,t,n,r){e&&e[_DYN_THROW_INTERNAL](3,108,"".concat(n," [").concat(t,"] failed - ")+dumpObj(r))};function _patchArray(a,o,_){isArray(o)&&arrForEach(arrayMethodsToPatch,function(e){var r=o[e];o[e]=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];var n=r[_DYN_APPLY](this,e);return _makeDynamicObject(a,o,_,"Patching"),n}})}function _getOwnPropGetter(e,t){e=objGetOwnPropertyDescriptor(e,t);return e&&e.get}function _createDynamicProperty(a,o,_,i){var s={n:_,h:[],trk:function(e){e&&e.fn&&(-1===arrIndexOf(s.h,e)&&s.h[_DYN_PUSH](e),a.trk(e,s))},clr:function(e){e=arrIndexOf(s.h,e);-1!==e&&s.h[_DYN_SPLICE](e,1)}},c=!0,u=!1;function l(){c&&(u=u||_canMakeDynamic(l,a,i),i&&!i[CFG_HANDLER_LINK]&&u&&(i=_makeDynamicObject(a,i,_,"Converting")),c=!1);var e=a.act;return e&&s.trk(e),i}l[a.prop]={chng:function(){a.add(s)}},objDefine(o,s.n,{g:l,s:function(t){if(i!==t){l[a.ro]&&!a.upd&&throwInvalidAccess("["+_+"] is read-only:"+dumpObj(o)),c&&(u=u||_canMakeDynamic(l,a,i),c=!1);var e,n=u&&l[a.rf];if(u)if(n){objForEachKey(i,function(e){i[e]=t?t[e]:UNDEFINED_VALUE});try{objForEachKey(t,function(e,t){_setDynamicProperty(a,i,e,t)}),t=i}catch(r){_throwDynamicError((a.hdlr||{})[_DYN_LOGGER],_,"Assigning",r),u=!1}}else i&&i[CFG_HANDLER_LINK]&&objForEachKey(i,function(e){var e=_getOwnPropGetter(i,e);e&&(e=e[a.prop])&&e.chng()});t!==i&&(e=t&&_canMakeDynamic(l,a,t),!n&&e&&(t=_makeDynamicObject(a,t,_,"Converting")),i=t,u=e),a.add(s)}}})}function _setDynamicProperty(e,t,n,r){var a;return t&&((a=_getOwnPropGetter(t,n))&&a[e.prop]?t[n]=r:_createDynamicProperty(e,t,n,r)),t}function _setDynamicPropertyState(e,t,n,r){if(t){var a=_getOwnPropGetter(t,n),o=a&&!!a[e.prop],_=r&&r[0],i=r&&r[1],r=r&&r[2];if(!o){if(r)try{blockDynamicConversion(t)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"Blocking",s)}try{_setDynamicProperty(e,t,n,t[n]),a=_getOwnPropGetter(t,n)}catch(s){_throwDynamicError((e.hdlr||{})[_DYN_LOGGER],n,"State",s)}}_&&(a[e.rf]=_),i&&(a[e.ro]=i),r&&(a[e.blkVal]=!0)}return t}function _makeDynamicObject(n,r,e,t){try{objForEachKey(r,function(e,t){_setDynamicProperty(n,r,e,t)}),r[CFG_HANDLER_LINK]||(objDefineProp(r,CFG_HANDLER_LINK,{get:function(){return n.hdlr}}),_patchArray(n,r,e))}catch(a){_throwDynamicError((n.hdlr||{})[_DYN_LOGGER],e,t,a)}return r}var symPrefix="[[ai_",symPostfix="]]";function _createState(o){var _,e=newSymbol(symPrefix+"get"+o.uid+symPostfix),t=newSymbol(symPrefix+"ro"+o.uid+symPostfix),n=newSymbol(symPrefix+"rf"+o.uid+symPostfix),r=newSymbol(symPrefix+"blkVal"+o.uid+symPostfix),i=newSymbol(symPrefix+"dtl"+o.uid+symPostfix),a=null,s=null;function c(t,e){var n=_.act;try{(_.act=t)&&t[i]&&(arrForEach(t[i],function(e){e.clr(t)}),t[i]=[]),e({cfg:o.cfg,set:o.set.bind(o),setDf:o.setDf.bind(o),ref:o.ref.bind(o),rdOnly:o.rdOnly.bind(o)})}catch(a){var r=o[_DYN_LOGGER];throw r&&r[_DYN_THROW_INTERNAL](1,107,dumpObj(a)),a}finally{_.act=n||null}}function u(){if(a){var e=a,n=(a=null,s&&s[_DYN_CANCEL](),s=null,[]);if(arrForEach(e,function(t){if(t&&(t[i]&&(arrForEach(t[i],function(e){e.clr(t)}),t[i]=null),t.fn))try{c(t,t.fn)}catch(e){n[_DYN_PUSH](e)}}),a)try{u()}catch(t){n[_DYN_PUSH](t)}0<n[_DYN_LENGTH$2]&&throwAggregationError("Watcher error(s): ",n)}}return _={prop:e,ro:t,rf:n,blkVal:r,hdlr:o,add:function(e){if(e&&0<e.h[_DYN_LENGTH$2]){a=a||[],s=s||scheduleTimeout(function(){s=null,u()},0);for(var t=0;t<e.h[_DYN_LENGTH$2];t++){var n=e.h[t];n&&-1===arrIndexOf(a,n)&&a[_DYN_PUSH](n)}}},notify:u,use:c,trk:function(e,t){e&&(e=e[i]=e[i]||[],-1===arrIndexOf(e,t)&&e[_DYN_PUSH](t))}}}function _createAndUseHandler(e,t){var n={fn:t,rm:function(){n.fn=null,t=e=null}};return objDefine(n,"toJSON",{v:function(){return"WatcherHandler"+(n.fn?"":"[X]")}}),e.use(n,t),n}function _createDynamicHandler(a,e,t){var n=getDynamicConfigHandler(e);if(n)return n;var o,n=createUniqueNamespace("dyncfg",!0),t=e&&!1!==t?e:_cfgDeepCopy(e),r={uid:null,cfg:t,logger:a,notify:function(){o.notify()},set:function(e,t,n){try{e=_setDynamicProperty(o,e,t,n)}catch(r){_throwDynamicError(a,t,"Setting value",r)}return e[t]},setDf:function(n,e){return e&&objForEachKey(e,function(e,t){_applyDefaultValue(r,n,e,t)}),n},watch:function(e){return _createAndUseHandler(o,e)},ref:function(e,t){return _setDynamicPropertyState(o,e,t,((e={})[0]=!0,e))[t]},rdOnly:function(e,t){return _setDynamicPropertyState(o,e,t,((e={})[1]=!0,e))[t]},blkVal:function(e,t){return _setDynamicPropertyState(o,e,t,((e={})[2]=!0,e))[t]},_block:function(n,r){o.use(null,function(e){var t=o.upd;try{isUndefined(r)||(o.upd=r),n(e)}finally{o.upd=t}})}};return objDefine(r,"uid",{c:!1,e:!1,w:!1,v:n}),_makeDynamicObject(o=_createState(r),t,"config","Creating"),r}function _logInvalidAccess(e,t){e?(e[_DYN_WARN_TO_CONSOLE](t),e[_DYN_THROW_INTERNAL](2,108,t)):throwInvalidAccess(t)}function createDynamicConfig(e,t,n,r){n=_createDynamicHandler(n,e||{},r);return t&&n.setDf(n.cfg,t),n}function onConfigChange(e,t,n){var r=e[CFG_HANDLER_LINK]||e;return!r.cfg||r.cfg!==e&&r.cfg[CFG_HANDLER_LINK]!==r?(_logInvalidAccess(n,STR_NOT_DYNAMIC_ERROR+dumpObj(e)),createDynamicConfig(e,null,n)[_DYN_WATCH](t)):r[_DYN_WATCH](t)}var _a$2,_aiNamespace=null;function _getExtensionNamespace(){var e=getInst("Microsoft");return _aiNamespace=e?e.ApplicationInsights:_aiNamespace}function getDebugExt(e){var t=_aiNamespace;return(t=t||!0===e.disableDbgExt?t:_aiNamespace||_getExtensionNamespace())?t.ChromeDbgExt:null}var STR_WARN_TO_CONSOLE="warnToConsole",AiNonUserActionablePrefix="AI (Internal): ",AiUserActionablePrefix="AI: ",AIInternalMessagePrefix="AITR_",defaultValues$1={loggingLevelConsole:0,loggingLevelTelemetry:1,maxMessageLimit:25,enableDebug:!1},_logFuncs=((_a$2={})[0]=null,_a$2[1]="errorToConsole",_a$2[2]=STR_WARN_TO_CONSOLE,_a$2[3]="debugToConsole",_a$2);function _sanitizeDiagnosticText(e){return e?'"'+e[_DYN_REPLACE](/\"/g,STR_EMPTY)+'"':STR_EMPTY}function _logToConsole(e,t){var n,r=getConsole();r&&(n="log",r[e]&&(n=e),isFunction(r[n])&&r[n](t))}var _InternalLogMessage=function(){function e(e,t,n,r){void 0===n&&(n=!1),this[_DYN_MESSAGE_ID]=e,this[_DYN_MESSAGE]=(n?AiUserActionablePrefix:AiNonUserActionablePrefix)+e;n=STR_EMPTY,hasJSON()&&(n=getJSON().stringify(r)),e=(t?" message:"+_sanitizeDiagnosticText(t):STR_EMPTY)+(r?" props:"+_sanitizeDiagnosticText(n):STR_EMPTY);this[_DYN_MESSAGE]+=e}return e.dataType="MessageData",e}();function safeGetLogger(e,t){return(e||{})[_DYN_LOGGER]||new DiagnosticLogger(t)}var DiagnosticLogger=function(){function e(r){this.identifier="DiagnosticLogger",this.queue=[];var s,a,c,u,t,l=0,E={};dynamicProto(e,this,function(o){function _(e,t){var n,r;c<=l||(r=!0,n=AIInternalMessagePrefix+t[_DYN_MESSAGE_ID],E[n]?r=!1:E[n]=!0,r&&(e<=a&&(o.queue[_DYN_PUSH](t),l++,i(1===e?"error":"warn",t)),l===c&&(r=new _InternalLogMessage(23,n="Internal events throttle limit per PageView reached for this app.",!1),o.queue[_DYN_PUSH](r),1===e?o.errorToConsole(n):o[_DYN_WARN_TO_CONSOLE](n))))}function i(e,t){var n=getDebugExt(r||{});n&&n[_DYN_DIAG_LOG]&&n[_DYN_DIAG_LOG](e,t)}t=onConfigChange(createDynamicConfig(r||{},defaultValues$1,o).cfg,function(e){e=e.cfg;s=e[_DYN_LOGGING_LEVEL_CONSOL4],a=e.loggingLevelTelemetry,c=e.maxMessageLimit,u=e.enableDebug}),o.consoleLoggingLevel=function(){return s},o[_DYN_THROW_INTERNAL]=function(e,t,n,r,a){t=new _InternalLogMessage(t,n,a=void 0!==a&&a,r);if(u)throw dumpObj(t);n=_logFuncs[e]||STR_WARN_TO_CONSOLE;isUndefined(t[_DYN_MESSAGE])?i("throw"+(1===e?"Critical":"Warning"),t):(a?(r=+t[_DYN_MESSAGE_ID],!E[r]&&e<=s&&(o[n](t[_DYN_MESSAGE]),E[r]=!0)):e<=s&&o[n](t[_DYN_MESSAGE]),_(e,t))},o.debugToConsole=function(e){_logToConsole("debug",e),i("warning",e)},o[_DYN_WARN_TO_CONSOLE]=function(e){_logToConsole("warn",e),i("warning",e)},o.errorToConsole=function(e){_logToConsole("error",e),i("error",e)},o.resetInternalMessageCount=function(){l=0,E={}},o.logInternalMessage=_,o[_DYN_UNLOAD]=function(e){t&&t.rm(),t=null}})}return e.__ieDyn=1,e}();function _getLogger(e){return e||new DiagnosticLogger}function _throwInternal(e,t,n,r,a,o){void 0===o&&(o=!1),_getLogger(e)[_DYN_THROW_INTERNAL](t,n,r,a,o)}var strExecutionContextKey="ctx",strParentContextKey="ParentContextKey",strChildrenContextKey="ChildrenContextKey",PerfEvent=function(){function o(e,t,n){var r,a=this;a.start=utcNow(),a[_DYN_NAME$1]=e,a.isAsync=n,a[_DYN_IS_CHILD_EVT]=function(){return!1},isFunction(t)&&objDefine(a,"payload",{g:function(){return!r&&isFunction(t)&&(r=t(),t=null),r}}),a[_DYN_GET_CTX]=function(e){return e?(e===o[strParentContextKey]||e===o[strChildrenContextKey]?a:a[strExecutionContextKey]||{})[e]:null},a[_DYN_SET_CTX]=function(e,t){e&&(e===o[strParentContextKey]?(a[e]||(a[_DYN_IS_CHILD_EVT]=function(){return!0}),a[e]=t):e===o[strChildrenContextKey]?a[e]=t:(a[strExecutionContextKey]=a[strExecutionContextKey]||{})[e]=t)},a.complete=function(){var e=0,t=a[_DYN_GET_CTX](o[strChildrenContextKey]);if(isArray(t))for(var n=0;n<t[_DYN_LENGTH$2];n++){var r=t[n];r&&(e+=r.time)}a.time=utcNow()-a.start,a.exTime=a.time-e,a.complete=function(){}}}return o.ParentContextKey="parent",o.ChildrenContextKey="childEvts",o}(),doPerfActiveKey="CoreUtils.doPerf";function doPerf(e,t,n,r,a){if(e)if(e=e[STR_GET_PERF_MGR]?e[STR_GET_PERF_MGR]():e){var o,_=void 0,i=e[_DYN_GET_CTX](doPerfActiveKey);try{if(_=e.create(t(),r,a))return i&&_[_DYN_SET_CTX]&&(_[_DYN_SET_CTX](PerfEvent[strParentContextKey],i),i[_DYN_GET_CTX]&&i[_DYN_SET_CTX]&&((o=i[_DYN_GET_CTX](PerfEvent[strChildrenContextKey]))||(o=[],i[_DYN_SET_CTX](PerfEvent[strChildrenContextKey],o)),o[_DYN_PUSH](_))),e[_DYN_SET_CTX](doPerfActiveKey,_),n(_)}catch(s){_&&_[_DYN_SET_CTX]&&_[_DYN_SET_CTX]("exception",s)}finally{_&&e.fire(_),e[_DYN_SET_CTX](doPerfActiveKey,i)}}return n()}function generateW3CId(){for(var e,t=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"],n=STR_EMPTY,r=0;r<4;r++)n+=t[15&(e=random32())]+t[e>>4&15]+t[e>>8&15]+t[e>>12&15]+t[e>>16&15]+t[e>>20&15]+t[e>>24&15]+t[e>>28&15];var a=t[8+(3&random32())|0];return strSubstr(n,0,8)+strSubstr(n,9,4)+"4"+strSubstr(n,13,3)+a+strSubstr(n,16,3)+strSubstr(n,19,12)}var DEFAULT_VERSION="00",INVALID_VERSION="ff",INVALID_TRACE_ID="00000000000000000000000000000000",INVALID_SPAN_ID="0000000000000000";function _isValid(e,t,n){return!(!e||e[_DYN_LENGTH$2]!==t||e===n||!e.match(/^[\da-f]*$/i))}function _formatValue(e,t,n){return _isValid(e,t)?e:n}function _formatFlags(e){for(var t=(e=isNaN(e)||e<0||255<e?1:e).toString(16);t[_DYN_LENGTH$2]<2;)t="0"+t;return t}function createTraceParent(e,t,n,r){return{version:_isValid(r,2,INVALID_VERSION)?r:DEFAULT_VERSION,traceId:isValidTraceId(e)?e:generateW3CId(),spanId:isValidSpanId(t)?t:strLeft(generateW3CId(),16),traceFlags:0<=n&&n<=255?n:1}}function isValidTraceId(e){return _isValid(e,32,INVALID_TRACE_ID)}function isValidSpanId(e){return _isValid(e,16,INVALID_SPAN_ID)}function formatTraceParent(e){var t,n;return e?(_isValid(t=_formatFlags(e[_DYN_TRACE_FLAGS$1]),2)||(t="01"),n=e[_DYN_VERSION]||DEFAULT_VERSION,"".concat((n="00"!==n&&"ff"!==n?DEFAULT_VERSION:n).toLowerCase(),"-").concat(_formatValue(e.traceId,32,INVALID_TRACE_ID).toLowerCase(),"-").concat(_formatValue(e.spanId,16,INVALID_SPAN_ID).toLowerCase(),"-").concat(t.toLowerCase())):""}var pluginStateData=createElmNodeData("plugin");function _getPluginState(e){return pluginStateData.get(e,"state",{},!0)}var _a$1,strTelemetryPluginChain="TelemetryPluginChain",strHasRunFlags="_hasRun",strGetTelCtx="_getTelCtx",_chainId=0;function _getNextProxyStart(e,t,n){for(;e;){if(e[_DYN_GET_PLUGIN]()===n)return e;e=e[_DYN_GET_NEXT]()}return createTelemetryProxyChain([n],t.config||{},t)}function _createInternalContext(e,o,n,t){var r=null,a=[],_=(o=o||createDynamicConfig({},null,n[_DYN_LOGGER]),null!==t&&(r=t?_getNextProxyStart(e,n,t):e),{_next:function(){var e,t=r;return r=t?t[_DYN_GET_NEXT]():null,t||(e=a)&&0<e[_DYN_LENGTH$2]&&(arrForEach(e,function(e){try{e.func.call(e.self,e.args)}catch(t){_throwInternal(n[_DYN_LOGGER],2,73,"Unexpected Exception during onComplete - "+dumpObj(t))}}),a=[]),t},ctx:{core:function(){return n},diagLog:function(){return safeGetLogger(n,o.cfg)},getCfg:function(){return o.cfg},getExtCfg:function(e,t){var r=i(e,!0);return t&&objForEachKey(t,function(e,t){var n;!isNullOrUndefined(r[e])||!(n=o.cfg[e])&&isNullOrUndefined(n)||(r[e]=n),_applyDefaultValue(o,r,e,t)}),o.setDf(r,t)},getConfig:function(e,t,n){void 0===n&&(n=!1);var r,e=i(e,!1),a=o.cfg;return!e||!e[t]&&isNullOrUndefined(e[t])?!a[t]&&isNullOrUndefined(a[t])||(r=a[t]):r=e[t],r||!isNullOrUndefined(r)?r:n},hasNext:function(){return!!r},getNext:function(){return r},setNext:function(e){r=e},iterate:function(e){for(;t=_._next();){var t=t[_DYN_GET_PLUGIN]();t&&e(t)}},onComplete:function(e,t){for(var n=[],r=2;r<arguments.length;r++)n[r-2]=arguments[r];e&&a[_DYN_PUSH]({func:e,self:isUndefined(t)?_.ctx:t,args:n})}}});function i(e,t){var n,r=null,a=o.cfg;return a&&e&&(n=a[STR_EXTENSION_CONFIG],a[STR_EXTENSION_CONFIG]=n=!n&&t?{}:n,(n=o.ref(a,STR_EXTENSION_CONFIG))&&(r=n[e],n[e]=r=!r&&t?{}:r,r=o.ref(n,e))),r}return _}function createProcessTelemetryContext(e,t,n,r){var a=createDynamicConfig(t),o=_createInternalContext(e,a,n,r),_=o.ctx;return _[_DYN_PROCESS_NEXT]=function(e){var t=o._next();return t&&t[STR_PROCESS_TELEMETRY](e,_),!t},_[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,a.cfg,n,t):e)||_[_DYN_GET_NEXT](),a.cfg,n,t)},_}function createProcessTelemetryUnloadContext(e,n,t){var r=createDynamicConfig(n.config),a=_createInternalContext(e,r,n,t),o=a.ctx;return o[_DYN_PROCESS_NEXT]=function(e){var t=a._next();return t&&t[_DYN_UNLOAD](o,e),!t},o[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUnloadContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||o[_DYN_GET_NEXT](),n,t)},o}function createProcessTelemetryUpdateContext(e,n,t){var r=createDynamicConfig(n.config),a=_createInternalContext(e,r,n,t).ctx;return a[_DYN_PROCESS_NEXT]=function(t){return a.iterate(function(e){isFunction(e[_DYN_UPDATE])&&e[_DYN_UPDATE](a,t)})},a[_DYN_CREATE_NEW]=function(e,t){return createProcessTelemetryUpdateContext((e=isArray(e=void 0===e?null:e)?createTelemetryProxyChain(e,r.cfg,n,t):e)||a[_DYN_GET_NEXT](),n,t)},a}function createTelemetryProxyChain(e,t,n,r){var a,o=null,_=!r;return isArray(e)&&0<e[_DYN_LENGTH$2]&&(a=null,arrForEach(e,function(e){(_=!_&&r===e||_)&&e&&isFunction(e[STR_PROCESS_TELEMETRY])&&(e=createTelemetryPluginProxy(e,t,n),o=o||e,a&&a._setNext(e),a=e)})),r&&!o?createTelemetryProxyChain([r],t,n):o}function createTelemetryPluginProxy(s,r,a){var c=null,o=isFunction(s[STR_PROCESS_TELEMETRY]),_=isFunction(s[_DYN_SET_NEXT_PLUGIN]),u=s?s[_DYN_IDENTIFIER]+"-"+s[STR_PRIORITY]+"-"+_chainId++:"Unknown-0-"+_chainId++,i={getPlugin:function(){return s},getNext:function(){return c},processTelemetry:function(n,e){var t;l(e=e||(t=(t=s&&isFunction(s[strGetTelCtx])?s[strGetTelCtx]():t)||createProcessTelemetryContext(i,r,a)),function(e){if(!s||!o)return!1;var t=_getPluginState(s);return!t[_DYN_TEARDOWN]&&!t[STR_DISABLED]&&(_&&s[_DYN_SET_NEXT_PLUGIN](c),s[STR_PROCESS_TELEMETRY](n,e),!0)},"processTelemetry",function(){return{item:n}},!n.sync)||e[_DYN_PROCESS_NEXT](n)},unload:function(r,a){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||(e[STR_CORE]=null,e[_DYN_TEARDOWN]=!0,e[_DYN_IS_INITIALIZED]=!1,s[_DYN_TEARDOWN]&&!0===s[_DYN_TEARDOWN](r,a)&&(n=!0))),n},"unload",function(){},a.isAsync)||r[_DYN_PROCESS_NEXT](a)},update:function(r,a){l(r,function(){var e,t,n=!1;return s&&(e=_getPluginState(s),t=s[STR_CORE]||e[STR_CORE],!s||t&&t!==r.core()||e[_DYN_TEARDOWN]||s[_DYN_UPDATE]&&!0===s[_DYN_UPDATE](r,a)&&(n=!0)),n},"update",function(){},!1)||r[_DYN_PROCESS_NEXT](a)},_id:u,_setNext:function(e){c=e}};function l(n,r,a,e,t){var o=!1,_=s?s[_DYN_IDENTIFIER]:strTelemetryPluginChain,i=(i=n[strHasRunFlags])||(n[strHasRunFlags]={});return n.setNext(c),s&&doPerf(n[STR_CORE](),function(){return _+":"+a},function(){i[u]=!0;try{var e=c?c._id:STR_EMPTY;e&&(i[e]=!1),o=r(n)}catch(t){e=!c||i[c._id];e&&(o=!0),c&&e||_throwInternal(n[_DYN_DIAG_LOG](),1,73,"Plugin ["+_+"] failed during "+a+" - "+dumpObj(t)+", run flags: "+dumpObj(i))}},e,t),o}return objFreeze(i)}function createUnloadHandlerContainer(){var t=[];return{add:function(e){e&&t[_DYN_PUSH](e)},run:function(n,r){arrForEach(t,function(e){try{e(n,r)}catch(t){_throwInternal(n[_DYN_DIAG_LOG](),2,73,"Unexpected error calling unload handler - "+dumpObj(t))}}),t=[]}}}function createUnloadHookContainer(){var t=[];return{run:function(n){var e=t;t=[],arrForEach(e,function(e){try{(e.rm||e.remove).call(e)}catch(t){_throwInternal(n,2,73,"Unloading:"+dumpObj(t))}})},add:function(e){e&&arrAppend(t,e)}}}var strGetPlugin="getPlugin",defaultValues=((_a$1={})[STR_EXTENSION_CONFIG]={isVal:isNotNullOrUndefined,v:{}},_a$1),BaseTelemetryPlugin=function(){function e(){var a,o,c,u,l,_=this;function t(e){var t,e=e=void 0===e?null:e;return e||(t=o||createProcessTelemetryContext(null,{},_[STR_CORE]),e=c&&c[strGetPlugin]?t[_DYN_CREATE_NEW](null,c[strGetPlugin]):t[_DYN_CREATE_NEW](null,c)),e}function i(e,t,n){createDynamicConfig(e,defaultValues,safeGetLogger(t)),!n&&t&&(n=t[_DYN_GET_PROCESS_TEL_CONT2]()[_DYN_GET_NEXT]());var r=c;c&&c[strGetPlugin]&&(r=c[strGetPlugin]()),_[STR_CORE]=t,o=createProcessTelemetryContext(n,e,t,r)}function E(){a=!1,_[STR_CORE]=null,c=o=null,l=createUnloadHookContainer(),u=createUnloadHandlerContainer()}E(),dynamicProto(e,_,function(s){s[_DYN_INITIALIZE]=function(e,t,n,r){i(e,t,r),a=!0},s[_DYN_TEARDOWN]=function(e,t){var n,r,a,o,_=s[STR_CORE];if(_&&(!e||_===e[STR_CORE]()))return r=!1,a=e||createProcessTelemetryUnloadContext(null,_,c&&c[strGetPlugin]?c[strGetPlugin]():c),o=t||{reason:0,isAsync:!1},s[_DYN__DO_TEARDOWN]&&!0===s[_DYN__DO_TEARDOWN](a,o,i)?n=!0:i(),n;function i(){r||(r=!0,u.run(a,t),l.run(a[_DYN_DIAG_LOG]()),!0===n&&a[_DYN_PROCESS_NEXT](o),E())}},s[_DYN_UPDATE]=function(e,t){var n,r,a,o=s[STR_CORE];if(o&&(!e||o===e[STR_CORE]()))return r=!1,a=e||createProcessTelemetryUpdateContext(null,o,c&&c[strGetPlugin]?c[strGetPlugin]():c),s._doUpdate&&!0===s._doUpdate(a,t||{reason:0},_)?n=!0:_(),n;function _(){r||(r=!0,i(a.getCfg(),a.core(),a[_DYN_GET_NEXT]()))}},proxyFunctionAs(s,"_addUnloadCb",function(){return u},"add"),proxyFunctionAs(s,"_addHook",function(){return l},"add"),objDefine(s,"_unloadHooks",{g:function(){return l}})}),_[_DYN_DIAG_LOG]=function(e){return t(e)[_DYN_DIAG_LOG]()},_[_DYN_IS_INITIALIZED]=function(){return a},_.setInitialized=function(e){a=e},_[_DYN_SET_NEXT_PLUGIN]=function(e){c=e},_[_DYN_PROCESS_NEXT]=function(e,t){t?t[_DYN_PROCESS_NEXT](e):c&&isFunction(c[STR_PROCESS_TELEMETRY])&&c[STR_PROCESS_TELEMETRY](e,null)},_._getTelCtx=t}return e.__ieDyn=1,e}(),strOnPrefix="on",strAttachEvent="attachEvent",strAddEventHelper="addEventListener",strEvents="events",rRemoveEmptyNs=(createUniqueNamespace("aiEvtPageHide"),createUniqueNamespace("aiEvtPageShow"),/\.[\.]+/g),rRemoveTrailingEmptyNs=/[\.]+$/,_guid=1,elmNodeData=createElmNodeData("events"),eventNamespace=/^([^.]*)(?:\.(.+)|)/;function _normalizeNamespace(e){return e&&e[_DYN_REPLACE]?e[_DYN_REPLACE](/^[\s\.]+|(?=[\s\.])[\.\s]+$/g,STR_EMPTY):e}function _getEvtNamespace(e,t){t&&(n=STR_EMPTY,isArray(t)?(n=STR_EMPTY,arrForEach(t,function(e){(e=_normalizeNamespace(e))&&("."!==e[0]&&(e="."+e),n+=e)})):n=_normalizeNamespace(t),n&&("."!==n[0]&&(n="."+n),e=(e||STR_EMPTY)+n));var n,t=eventNamespace.exec(e||STR_EMPTY)||[];return{type:t[1],ns:(t[2]||STR_EMPTY).replace(rRemoveEmptyNs,".").replace(rRemoveTrailingEmptyNs,STR_EMPTY)[_DYN_SPLIT$1](".").sort().join(".")}}function _getRegisteredEvents(e,t,n){e=elmNodeData.get(e,strEvents,{},n=void 0===n||n);return e[t]||(e[t]=[])}function _doAttach(e,t,n,r){var a=!1;return e&&t&&t[_DYN_TYPE]&&n&&(e[strAddEventHelper]?(e[strAddEventHelper](t[_DYN_TYPE],n,r),a=!0):e[strAttachEvent]&&(e[strAttachEvent](strOnPrefix+t[_DYN_TYPE],n),a=!0)),a}function mergeEvtNamespace(e,t){return t?_getEvtNamespace("xx",isArray(t)?[e].concat(t):[e,t]).ns[_DYN_SPLIT$1]("."):e}function eventOn(e,t,n,r,a){void 0===a&&(a=!1);var o=!1;if(e)try{var _,i=_getEvtNamespace(t,r);(o=_doAttach(e,i,n,a))&&elmNodeData.accept(e)&&(_={guid:_guid++,evtName:i,handler:n,capture:a},_getRegisteredEvents(e,i.type)[_DYN_PUSH](_))}catch(s){}return o}var aiInstrumentHooks="_aiHooks",cbNames=["req","rsp","hkErr","fnErr"];function _arrLoop(e,t){if(e)for(var n=0;n<e[_DYN_LENGTH$2]&&!t(e[n],n);n++);}function _doCallbacks(e,_,i,s,c){0<=c&&c<=2&&_arrLoop(e,function(e,t){var e=e.cbks,n=e[cbNames[c]];if(n){_.ctx=function(){return s[t]=s[t]||{}};try{n[_DYN_APPLY](_.inst,i)}catch(a){n=_.err;try{var r=e[cbNames[2]];r&&(_.err=a,r[_DYN_APPLY](_.inst,i))}catch(o){}finally{_.err=n}}}})}function _createFunctionHook(s){return function(){var n=arguments,e=s.h,r={name:s.n,inst:this,ctx:null,set:function(e,t){(n=o([],n))[e]=t,a=o([r],n)}},t=[],a=o([r],n);function o(t,e){return _arrLoop(e,function(e){t[_DYN_PUSH](e)}),t}r.evt=getInst("event"),_doCallbacks(e,r,a,t,0);var _=s.f;if(_)try{r.rslt=_[_DYN_APPLY](this,n)}catch(i){throw r.err=i,_doCallbacks(e,r,a,t,3),i}return _doCallbacks(e,r,a,t,1),r.rslt}}function _getOwner(e,t,n,r){var a=null;return e&&(objHasOwnProperty(e,t)?a=e:n&&(a=_getOwner(_getObjProto(e),t,r,!1))),a}function InstrumentProto(e,t,n){return e?InstrumentFunc(e[strShimPrototype],t,n,!1):null}function _createInstrumentHook(e,t,n,r){var a=n&&n[aiInstrumentHooks],t=(a||((n=_createFunctionHook(a={i:0,n:t,f:n,h:[]}))[aiInstrumentHooks]=a,e[t]=n),{id:a.i,cbks:r,rm:function(){var n=this.id;_arrLoop(a.h,function(e,t){if(e.id===n)return a.h[_DYN_SPLICE](t,1),1})}});return a.i++,a.h[_DYN_PUSH](t),t}function InstrumentFunc(e,t,n,r,a){if(void 0===r&&(r=!0),e&&t&&n){e=_getOwner(e,t,r,a);if(e){r=e[t];if(typeof r===strShimFunction)return _createInstrumentHook(e,t,r,n)}}return null}var DisabledPropertyName="Microsoft_ApplicationInsights_BypassAjaxInstrumentation",DEFAULT_BREEZE_ENDPOINT="https://dc.services.visualstudio.com",DEFAULT_BREEZE_PATH="/v2/track",strNotSpecified="not_specified",strIkey="iKey",RequestHeaders=createValueMap({requestContextHeader:[0,"Request-Context"],requestContextTargetKey:[1,"appId"],requestContextAppIdFormat:[2,"appId=cid-v1:"],requestIdHeader:[3,"Request-Id"],traceParentHeader:[4,"traceparent"],traceStateHeader:[5,"tracestate"],sdkContextHeader:[6,"Sdk-Context"],sdkContextHeaderAppIdRequest:[7,"appId"],requestContextHeaderLowerCase:[8,"request-context"]}),_DYN_SPLIT="split",_DYN_LENGTH$1="length",_DYN_TO_LOWER_CASE$1="toLowerCase",_DYN_STRINGIFY="stringify",_DYN_PATHNAME="pathname",_DYN_MATCH="match",_DYN_CORRELATION_HEADER_E0="correlationHeaderExcludePatterns",_DYN_NAME="name",_DYN_PROPERTIES="properties",_DYN_MEASUREMENTS="measurements",_DYN_DURATION="duration";function dataSanitizeKeyAndAddUniqueness(e,t,n){var r=t[_DYN_LENGTH$1],a=dataSanitizeKey(e,t);if(a[_DYN_LENGTH$1]!==r){for(var o=0,_=a;n[_]!==undefined;)o++,_=strSubstring(a,0,147)+dsPadNumber(o);a=_}return a}function dataSanitizeKey(e,t){var n;return t&&150<(t=strTrim(asString(t)))[_DYN_LENGTH$1]&&(n=strSubstring(t,0,150),_throwInternal(e,2,57,"name is too long.  It has been truncated to 150 characters.",{name:t},!0)),n||t}function dataSanitizeString(e,t,n){var r;return void 0===n&&(n=1024),t&&(n=n||1024,(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(r=strSubstring(t,0,n),_throwInternal(e,2,61,"string value is too long. It has been truncated to "+n+" characters.",{value:t},!0))),r||t}function dataSanitizeUrl(e,t){return dataSanitizeInput(e,t,2048,66)}function dataSanitizeProperties(r,e){var a;return e&&(a={},objForEachKey(e,function(e,t){if(isObject(t)&&hasJSON())try{t=getJSON()[_DYN_STRINGIFY](t)}catch(n){_throwInternal(r,2,49,"custom property is not valid",{exception:n},!0)}t=dataSanitizeString(r,t,8192),e=dataSanitizeKeyAndAddUniqueness(r,e,a),a[e]=t}),e=a),e}function dataSanitizeMeasurements(n,e){var r;return e&&(r={},objForEachKey(e,function(e,t){e=dataSanitizeKeyAndAddUniqueness(n,e,r),r[e]=t}),e=r),e}function dataSanitizeInput(e,t,n,r){var a;return t&&(t=strTrim(asString(t)))[_DYN_LENGTH$1]>n&&(a=strSubstring(t,0,n),_throwInternal(e,2,r,"input is too long, it has been truncated to "+n+" characters.",{data:t},!0)),a||t}function dsPadNumber(e){e="00"+e;return strSubstr(e,e[_DYN_LENGTH$1]-3)}var _document=getDocument()||{},_htmlAnchorIdx=0,_htmlAnchorElement=[null,null,null,null,null];function urlParseUrl(e){var t=_htmlAnchorIdx,n=_htmlAnchorElement,r=n[t];return _document.createElement?n[t]||(r=n[t]=_document.createElement("a")):r={host:urlParseHost(e,!0)},r.href=e,++t>=n[_DYN_LENGTH$1]&&(t=0),_htmlAnchorIdx=t,r}function urlGetAbsoluteUrl(e){e=urlParseUrl(e);return e?e.href:void 0}function urlGetCompleteUrl(e,t){return e?e.toUpperCase()+" "+t:t}function urlParseHost(e,t){e=urlParseFullHost(e,t)||"";if(e){t=e[_DYN_MATCH](/(www\d{0,5}\.)?([^\/:]{1,256})(:\d{1,20})?/i);if(null!=t&&3<t[_DYN_LENGTH$1]&&isString(t[2])&&0<t[2][_DYN_LENGTH$1])return t[2]+(t[3]||"")}return e}function urlParseFullHost(e,t){var n=null;return e&&null!=(e=e[_DYN_MATCH](/(\w{1,150}):\/\/([^\/:]{1,256})(:\d{1,20})?/i))&&2<e[_DYN_LENGTH$1]&&isString(e[2])&&0<e[2][_DYN_LENGTH$1]&&(n=e[2]||"",t&&2<e[_DYN_LENGTH$1]&&(t=(e[1]||"")[_DYN_TO_LOWER_CASE$1](),e=e[3]||"",n+=e="http"===t&&":80"===e||"https"===t&&":443"===e?"":e)),n}var _internalEndpoints=[DEFAULT_BREEZE_ENDPOINT+DEFAULT_BREEZE_PATH,"https://breeze.aimon.applicationinsights.io"+DEFAULT_BREEZE_PATH,"https://dc-int.services.visualstudio.com"+DEFAULT_BREEZE_PATH],_correlationIdPrefix="cid-v1:";function isInternalApplicationInsightsEndpoint(e){return-1!==arrIndexOf(_internalEndpoints,e[_DYN_TO_LOWER_CASE$1]())}function correlationIdCanIncludeCorrelationHeader(e,t,n){if(!t||e&&e.disableCorrelationHeaders)return!1;if(e&&e[_DYN_CORRELATION_HEADER_E0])for(var r=0;r<e.correlationHeaderExcludePatterns[_DYN_LENGTH$1];r++)if(e[_DYN_CORRELATION_HEADER_E0][r].test(t))return!1;var a=urlParseUrl(t).host[_DYN_TO_LOWER_CASE$1]();if(!a||-1===strIndexOf(a,":443")&&-1===strIndexOf(a,":80")||(a=(urlParseFullHost(t,!0)||"")[_DYN_TO_LOWER_CASE$1]()),(!e||!e.enableCorsCorrelation)&&a&&a!==n)return!1;var o,n=e&&e.correlationHeaderDomains;if(n&&(arrForEach(n,function(e){e=RegExp(e.toLowerCase().replace(/\\/g,"\\\\").replace(/\./g,"\\.").replace(/\*/g,".*"));o=o||e.test(a)}),!o))return!1;var _=e&&e.correlationHeaderExcludedDomains;if(!_||0===_[_DYN_LENGTH$1])return!0;for(r=0;r<_[_DYN_LENGTH$1];r++)if(RegExp(_[r].toLowerCase().replace(/\\/g,"\\\\").replace(/\./g,"\\.").replace(/\*/g,".*")).test(a))return!1;return a&&0<a[_DYN_LENGTH$1]}function correlationIdGetCorrelationContext(e){if(e){e=correlationIdGetCorrelationContextValue(e,RequestHeaders[1]);if(e&&e!==_correlationIdPrefix)return e}}function correlationIdGetCorrelationContextValue(e,t){if(e)for(var n=e[_DYN_SPLIT](","),r=0;r<n[_DYN_LENGTH$1];++r){var a=n[r][_DYN_SPLIT]("=");if(2===a[_DYN_LENGTH$1]&&a[0]===t)return a[1]}}function AjaxHelperParseDependencyPath(e,t,n,r){var a,o,_,i=r,s=r,i=t&&0<t[_DYN_LENGTH$1]?(_=(a=urlParseUrl(t)).host,i||(null!=a[_DYN_PATHNAME]?("/"!=((o=0===a.pathname[_DYN_LENGTH$1]?"/":a[_DYN_PATHNAME])[0]||"")&&(o="/"+o),s=a[_DYN_PATHNAME],dataSanitizeString(e,n?n+" "+o:o)):dataSanitizeString(e,t))):_=r;return{target:_,name:i,data:s}}function dateTimeUtilsNow(){var e=getPerformance();if(e&&e.now&&e.timing){e=e.now()+e.timing.navigationStart;if(0<e)return e}return utcNow()}function dateTimeUtilsDuration(e,t){return 0===e||0===t||isNullOrUndefined(e)||isNullOrUndefined(t)?null:t-e}function createDistributedTraceContextFromTrace(e,t){var n=e||{};return{getName:function(){return n[_DYN_NAME]},setName:function(e){t&&t.setName(e),n[_DYN_NAME]=e},getTraceId:function(){return n.traceID},setTraceId:function(e){t&&t.setTraceId(e),isValidTraceId(e)&&(n.traceID=e)},getSpanId:function(){return n.parentID},setSpanId:function(e){t&&t.setSpanId(e),isValidSpanId(e)&&(n.parentID=e)},getTraceFlags:function(){return n.traceFlags},setTraceFlags:function(e){t&&t.setTraceFlags(e),n.traceFlags=e}}}var strEmpty="";function msToTimeSpan(e){e=mathRound(e=isNaN(e)||e<0?0:e);var t=strEmpty+e%1e3,n=strEmpty+mathFloor(e/1e3)%60,r=strEmpty+mathFloor(e/6e4)%60,a=strEmpty+mathFloor(e/36e5)%24,e=mathFloor(e/864e5),t=1===t[_DYN_LENGTH$1]?"00"+t:2===t[_DYN_LENGTH$1]?"0"+t:t,n=n[_DYN_LENGTH$1]<2?"0"+n:n,r=r[_DYN_LENGTH$1]<2?"0"+r:r,a=a[_DYN_LENGTH$1]<2?"0"+a:a;return(0<e?e+".":strEmpty)+a+":"+r+":"+n+"."+t}var RemoteDependencyData=function(){function e(e,t,n,r,a,o,_,i,s,c,u,l){void 0===s&&(s="Ajax"),this.aiDataContract={id:1,ver:1,name:0,resultCode:0,duration:0,success:0,data:0,target:0,type:0,properties:0,measurements:0,kind:0,value:0,count:0,min:0,max:0,stdDev:0,dependencyKind:0,dependencySource:0,commandName:0,dependencyTypeName:0};var E=this,t=(E.ver=2,E.id=t,E[_DYN_DURATION]=msToTimeSpan(a),E.success=o,E.resultCode=_+"",E.type=dataSanitizeString(e,s),AjaxHelperParseDependencyPath(e,n,i,r));E.data=dataSanitizeUrl(e,r)||t.data,E.target=dataSanitizeString(e,t.target),c&&(E.target="".concat(E.target," | ").concat(c)),E[_DYN_NAME]=dataSanitizeString(e,t[_DYN_NAME]),E[_DYN_PROPERTIES]=dataSanitizeProperties(e,u),E[_DYN_MEASUREMENTS]=dataSanitizeMeasurements(e,l)}return e.envelopeType="Microsoft.ApplicationInsights.{0}.RemoteDependency",e.dataType="RemoteDependencyData",e}();function _aiNameFunc(e){var t="ai."+e+".";return function(e){return t+e}}var _aiApplication=_aiNameFunc("application"),_aiDevice=_aiNameFunc("device"),_aiLocation=_aiNameFunc("location"),_aiOperation=_aiNameFunc("operation"),_aiSession=_aiNameFunc("session"),_aiUser=_aiNameFunc("user"),_aiCloud=_aiNameFunc("cloud"),_aiInternal=_aiNameFunc("internal"),ContextTagKeys=function(e){function t(){return e.call(this)||this}return __extendsFn(t,e),t}(createClassFromInterface({applicationVersion:_aiApplication("ver"),applicationBuild:_aiApplication("build"),applicationTypeId:_aiApplication("typeId"),applicationId:_aiApplication("applicationId"),applicationLayer:_aiApplication("layer"),deviceId:_aiDevice("id"),deviceIp:_aiDevice("ip"),deviceLanguage:_aiDevice("language"),deviceLocale:_aiDevice("locale"),deviceModel:_aiDevice("model"),deviceFriendlyName:_aiDevice("friendlyName"),deviceNetwork:_aiDevice("network"),deviceNetworkName:_aiDevice("networkName"),deviceOEMName:_aiDevice("oemName"),deviceOS:_aiDevice("os"),deviceOSVersion:_aiDevice("osVersion"),deviceRoleInstance:_aiDevice("roleInstance"),deviceRoleName:_aiDevice("roleName"),deviceScreenResolution:_aiDevice("screenResolution"),deviceType:_aiDevice("type"),deviceMachineName:_aiDevice("machineName"),deviceVMName:_aiDevice("vmName"),deviceBrowser:_aiDevice("browser"),deviceBrowserVersion:_aiDevice("browserVersion"),locationIp:_aiLocation("ip"),locationCountry:_aiLocation("country"),locationProvince:_aiLocation("province"),locationCity:_aiLocation("city"),operationId:_aiOperation("id"),operationName:_aiOperation("name"),operationParentId:_aiOperation("parentId"),operationRootId:_aiOperation("rootId"),operationSyntheticSource:_aiOperation("syntheticSource"),operationCorrelationVector:_aiOperation("correlationVector"),sessionId:_aiSession("id"),sessionIsFirst:_aiSession("isFirst"),sessionIsNew:_aiSession("isNew"),userAccountAcquisitionDate:_aiUser("accountAcquisitionDate"),userAccountId:_aiUser("accountId"),userAgent:_aiUser("userAgent"),userId:_aiUser("id"),userStoreRegion:_aiUser("storeRegion"),userAuthUserId:_aiUser("authUserId"),userAnonymousUserAcquisitionDate:_aiUser("anonUserAcquisitionDate"),userAuthenticatedUserAcquisitionDate:_aiUser("authUserAcquisitionDate"),cloudName:_aiCloud("name"),cloudRole:_aiCloud("role"),cloudRoleVer:_aiCloud("roleVer"),cloudRoleInstance:_aiCloud("roleInstance"),cloudEnvironment:_aiCloud("environment"),cloudLocation:_aiCloud("location"),cloudDeploymentUnit:_aiCloud("deploymentUnit"),internalNodeName:_aiInternal("nodeName"),internalSdkVersion:_aiInternal("sdkVersion"),internalAgentVersion:_aiInternal("agentVersion"),internalSnippet:_aiInternal("snippet"),internalSdkSrc:_aiInternal("sdkSrc")}));function createTelemetryItem(e,t,n,r,a,o){n=dataSanitizeString(r,n)||strNotSpecified,(isNullOrUndefined(e)||isNullOrUndefined(t)||isNullOrUndefined(n))&&throwError("Input doesn't contain all required fields");var r="",_=(e[strIkey]&&(r=e[strIkey],delete e[strIkey]),{name:n,time:toISOString(new Date),iKey:r,ext:o||{},tags:[],data:{},baseType:t,baseData:e});return isNullOrUndefined(a)||objForEachKey(a,function(e,t){_.data[e]=t}),_}var Extensions={UserExt:"user",DeviceExt:"device",TraceExt:"trace",WebExt:"web",AppExt:"app",OSExt:"os",SessionExt:"ses",SDKExt:"sdk"},PropertiesPluginIdentifier=(new ContextTagKeys,"AppInsightsPropertiesPlugin"),STR_DURATION="duration",STR_PROPERTIES="properties",_DYN_REQUEST_URL="requestUrl",_DYN_LENGTH="length",_DYN_TRACE_ID="traceID",_DYN_SPAN_ID="spanID",_DYN_TRACE_FLAGS="traceFlags",_DYN_CONTEXT="context",_DYN_ABORTED="aborted",_DYN__ADD_HOOK="_addHook",_DYN_CORE="core",_DYN_INCLUDE_CORRELATION_0="includeCorrelationHeaders",_DYN_GET_ABSOLUTE_URL="getAbsoluteUrl",_DYN_HEADERS="headers",_DYN_REQUEST_HEADERS="requestHeaders",_DYN_SET_REQUEST_HEADER="setRequestHeader",_DYN_TRACK_DEPENDENCY_DAT1="trackDependencyDataInternal",_DYN_START_TIME="startTime",_DYN_TO_LOWER_CASE="toLowerCase",_DYN_ENABLE_REQUEST_HEADE2="enableRequestHeaderTracking",_DYN_ENABLE_AJAX_ERROR_ST3="enableAjaxErrorStatusText",_DYN_ENABLE_AJAX_PERF_TRA4="enableAjaxPerfTracking",_DYN_MAX_AJAX_CALLS_PER_V5="maxAjaxCallsPerView",_DYN_EXCLUDE_REQUEST_FROM6="excludeRequestFromAutoTrackingPatterns",_DYN_DISABLE_AJAX_TRACKIN7="disableAjaxTracking",_DYN_AJAX_PERF_LOOKUP_DEL8="ajaxPerfLookupDelay",_DYN_DISABLE_FETCH_TRACKI9="disableFetchTracking",_DYN_ENABLE_RESPONSE_HEAD10="enableResponseHeaderTracking",_DYN_STATUS="status",_DYN_STATUS_TEXT="statusText",_DYN_HEADER_MAP="headerMap",_DYN_REQUEST_SENT_TIME="requestSentTime",_DYN_GET_TRACE_ID="getTraceId",_DYN_GET_TRACE_FLAGS="getTraceFlags",_DYN_METHOD="method",_DYN_ERROR_STATUS_TEXT="errorStatusText",_DYN_STATE_CHANGE_ATTACHE11="stateChangeAttached",_DYN_RESPONSE_TEXT="responseText",_DYN_RESPONSE_FINISHED_TI12="responseFinishedTime",_DYN__CREATE_TRACK_ITEM="CreateTrackItem",_DYN_GET_ALL_RESPONSE_HEA13="getAllResponseHeaders",_DYN_GET_PART_APROPS="getPartAProps",_DYN_PERF_MARK="perfMark",_DYN_PERF_TIMING="perfTiming",_DYN_AJAX_DIAGNOSTICS_MES14="ajaxDiagnosticsMessage",_DYN_CORRELATION_CONTEXT="correlationContext",_DYN_AJAX_TOTAL_DURATION="ajaxTotalDuration",_DYN_EVENT_TRACE_CTX="eventTraceCtx";function _calcPerfDuration(e,t,n){t=e[t],n=e[n];return t&&n?dateTimeUtilsDuration(t,n):0}function _setPerfDuration(e,t,n,r,a){n=_calcPerfDuration(n,r,a);return n?_setPerfValue(e,t,msToTimeSpan(n)):0}function _setPerfValue(e,t,n){var r="ajaxPerf",a=0;return e&&t&&n&&((e[r]=e[r]||{})[t]=n,a=1),a}function _populatePerfData(e,t){var r,n=e[_DYN_PERF_TIMING],a=t[STR_PROPERTIES]||{},o=0,_="connect",i="request",s="response",c="startTime",u=_+"End",l=i+"Start",E=s+"End",N="transferSize",T="encodedBodySize",f="decodedBodySize",D="serverTiming";n?(o=(o=(o=(o=(o=(o=(o|=_setPerfDuration(a,"End",n,"redirectStart","End"))|_setPerfDuration(a,"domainLookup",n,"domainLookupStart","domainLookupEnd"))|_setPerfDuration(a,_,n,"connectStart",u))|_setPerfDuration(a,i,n,l,"requestEnd"))|_setPerfDuration(a,s,n,"responseStart",E))|_setPerfDuration(a,"networkConnect",n,c,u))|_setPerfDuration(a,"sentRequest",n,l,E),_=n[STR_DURATION]||_calcPerfDuration(n,c,E)||0,o=(o|=_setPerfValue(a,STR_DURATION,_))|_setPerfValue(a,"perfTotal",_),(i=n[D])&&(r={},arrForEach(i,function(e,t){var t=normalizeJsName(e.name||""+t),n=r[t]||{};objForEachKey(e,function(e,t){!("name"!==e&&isString(t)||isNumber(t))||!(t=n[e]?n[e]+";"+t:t)&&isString(t)||(n[e]=t)}),r[t]=n}),o|=_setPerfValue(a,D,r)),o=(o=(o|=_setPerfValue(a,N,n[N]))|_setPerfValue(a,T,n[T]))|_setPerfValue(a,f,n[f])):e[_DYN_PERF_MARK]&&(o|=_setPerfValue(a,"missing",e.perfAttempts)),o&&(t[STR_PROPERTIES]=a)}var _a,XHRMonitoringState=function(){var e=this;e.openDone=!1,e.setRequestHeaderDone=!1,e.sendDone=!1,e.abortDone=!1,e[_DYN_STATE_CHANGE_ATTACHE11]=!1},ajaxRecord=function(){function _(e,t,n,r){var a=this,o=n;a[_DYN_PERF_MARK]=null,a.completed=!1,a.requestHeadersSize=null,a[_DYN_REQUEST_HEADERS]=null,a.responseReceivingDuration=null,a.callbackDuration=null,a[_DYN_AJAX_TOTAL_DURATION]=null,a[_DYN_ABORTED]=0,a.pageUrl=null,a[_DYN_REQUEST_URL]=null,a.requestSize=0,a[_DYN_METHOD]=null,a[_DYN_STATUS]=null,a[_DYN_REQUEST_SENT_TIME]=null,a.responseStartedTime=null,a[_DYN_RESPONSE_FINISHED_TI12]=null,a.callbackFinishedTime=null,a.endTime=null,a.xhrMonitoringState=new XHRMonitoringState,a.clientFailure=0,a[_DYN_TRACE_ID]=e,a[_DYN_SPAN_ID]=t,a[_DYN_TRACE_FLAGS]=null==r?void 0:r.getTraceFlags(),a[_DYN_EVENT_TRACE_CTX]=r?{traceId:r[_DYN_GET_TRACE_ID](),spanId:r.getSpanId(),traceFlags:r[_DYN_GET_TRACE_FLAGS]()}:null,dynamicProto(_,a,function(a){a.getAbsoluteUrl=function(){return a[_DYN_REQUEST_URL]?urlGetAbsoluteUrl(a[_DYN_REQUEST_URL]):null},a.getPathName=function(){return a[_DYN_REQUEST_URL]?dataSanitizeUrl(o,urlGetCompleteUrl(a[_DYN_METHOD],a[_DYN_REQUEST_URL])):null},a[_DYN__CREATE_TRACK_ITEM]=function(e,t,n){if(a.ajaxTotalDuration=mathRound(1e3*dateTimeUtilsDuration(a.requestSentTime,a.responseFinishedTime))/1e3,a[_DYN_AJAX_TOTAL_DURATION]<0)return null;(e={id:"|"+a[_DYN_TRACE_ID]+"."+a[_DYN_SPAN_ID],target:a[_DYN_GET_ABSOLUTE_URL](),name:a.getPathName(),type:e,startTime:null,duration:a[_DYN_AJAX_TOTAL_DURATION],success:200<=+a[_DYN_STATUS]&&+a[_DYN_STATUS]<400,responseCode:+a[_DYN_STATUS]})[STR_PROPERTIES]={HttpMethod:a[_DYN_METHOD]};var r=e[STR_PROPERTIES];return a[_DYN_ABORTED]&&(r[_DYN_ABORTED]=!0),a[_DYN_REQUEST_SENT_TIME]&&(e[_DYN_START_TIME]=new Date,e[_DYN_START_TIME].setTime(a[_DYN_REQUEST_SENT_TIME])),_populatePerfData(a,e),t&&0<objKeys(a.requestHeaders)[_DYN_LENGTH]&&(r[_DYN_REQUEST_HEADERS]=a[_DYN_REQUEST_HEADERS]),n&&(t=n())&&((n=t[_DYN_CORRELATION_CONTEXT])&&(e.correlationContext=n),t[_DYN_HEADER_MAP]&&0<objKeys(t.headerMap)[_DYN_LENGTH]&&(r.responseHeaders=t[_DYN_HEADER_MAP]),a[_DYN_ERROR_STATUS_TEXT]&&(400<=a[_DYN_STATUS]?(""!==(n=t.type)&&"text"!==n||(r.responseText=t.responseText?t[_DYN_STATUS_TEXT]+" - "+t.responseText:t[_DYN_STATUS_TEXT]),"json"===n&&(r.responseText=t.response?t[_DYN_STATUS_TEXT]+" - "+JSON.stringify(t.response):t[_DYN_STATUS_TEXT])):0===a[_DYN_STATUS]&&(r.responseText=t[_DYN_STATUS_TEXT]||""))),e},a[_DYN_GET_PART_APROPS]=function(){var e,t=null,n=a[_DYN_EVENT_TRACE_CTX];return n&&(n.traceId||n.spanId)&&(e=(t={})[Extensions.TraceExt]={traceID:n.traceId,parentID:n.spanId},isNullOrUndefined(n[_DYN_TRACE_FLAGS])||(e[_DYN_TRACE_FLAGS]=n[_DYN_TRACE_FLAGS])),t}})}return _.__ieDyn=1,_}(),strDiagLog="diagLog",AJAX_DATA_CONTAINER="_ajaxData",STR_FETCH="fetch",ERROR_HEADER="Failed to monitor XMLHttpRequest",ERROR_PREFIX=", monitoring data for this ajax call ",ERROR_POSTFIX=ERROR_PREFIX+"may be incorrect.",ERROR_NOT_SENT=ERROR_PREFIX+"won't be sent.",CORRELATION_HEADER_ERROR="Failed to get Request-Context correlation header as it may be not included in the response or not accessible.",CUSTOM_REQUEST_CONTEXT_ERROR="Failed to add custom defined request context as configured call back may missing a null check.",FAILED_TO_CALCULATE_DURATION_ERROR="Failed to calculate the duration of the ",_markCount=0;function _supportsFetch(){var e=getGlobal();return!e||isNullOrUndefined(e.Request)||isNullOrUndefined(e.Request[strShimPrototype])||isNullOrUndefined(e[STR_FETCH])?null:e[STR_FETCH]}function _supportsAjaxMonitoring(e,t){var n,r=!1,a=(isXhrSupported()&&(r=!(isNullOrUndefined(a=XMLHttpRequest[strShimPrototype])||isNullOrUndefined(a.open)||isNullOrUndefined(a.send)||isNullOrUndefined(a.abort))),getIEVersion());if(r=!(a&&a<9)&&r)try{var o=new XMLHttpRequest,_={xh:[],i:((n={})[t]={},n)},i=(o[AJAX_DATA_CONTAINER]=_,XMLHttpRequest[strShimPrototype].open);XMLHttpRequest[strShimPrototype].open=i}catch(s){r=!1,_throwInternalCritical(e,15,"Failed to enable XMLHttpRequest monitoring, extension is not supported",{exception:dumpObj(s)})}return r}var _getAjaxData=function(e,t){return e&&t&&e[AJAX_DATA_CONTAINER]?(e[AJAX_DATA_CONTAINER].i||{})[t]:null},_addSharedXhrHeaders=function(e,t,n){e&&(e=(e[AJAX_DATA_CONTAINER]||{}).xh)&&e.push({n:t,v:n})},_isHeaderSet=function(e,t){var n=!1;return e&&(e=(e[AJAX_DATA_CONTAINER]||{}).xh)&&arrForEach(e,function(e){if(e.n===t)return n=!0,-1}),n};function _getFailedAjaxDiagnosticsMessage(e,t){var n="";try{var r=_getAjaxData(e,t);r&&r[_DYN_REQUEST_URL]&&(n+="(url: '"+r[_DYN_REQUEST_URL]+"')")}catch(a){}return n}function _throwInternalCritical(e,t,n,r,a){_throwInternal(e[strDiagLog](),1,t,n,r,a)}function _throwInternalWarning(e,t,n,r,a){_throwInternal(e[strDiagLog](),2,t,n,r,a)}function _createErrorCallbackFunc(n,r,a){return function(e){var t;_throwInternalCritical(n,r,a,((t={})[_DYN_AJAX_DIAGNOSTICS_MES14]=_getFailedAjaxDiagnosticsMessage(e.inst,n._ajaxDataId),t.exception=dumpObj(e.err),t))}}function _indexOf(e,t){return e&&t?strIndexOf(e,t):-1}function _addHandler(n,e,t){var r={id:e,fn:t};return n.push(r),{remove:function(){arrForEach(n,function(e,t){if(e.id===r.id)return n.splice(t,1),-1})}}}function _processDependencyContainer(r,e,a,o){var _=!0;return arrForEach(e,function(e,t){try{!1===e.fn.call(null,a)&&(_=!1)}catch(n){_throwInternal(r&&r.logger,1,64,"Dependency "+o+" [#"+t+"] failed: "+getExceptionName(n),{exception:dumpObj(n)},!0)}}),_}function _processDependencyListeners(e,t,n,r,a,o){0<e[_DYN_LENGTH]&&(_processDependencyContainer(t,e,e={core:t,xhr:r,input:a,init:o,traceId:n[_DYN_TRACE_ID],spanId:n[_DYN_SPAN_ID],traceFlags:n[_DYN_TRACE_FLAGS],context:n[_DYN_CONTEXT]||{},aborted:!!n[_DYN_ABORTED]},"listener"),n[_DYN_TRACE_ID]=e.traceId,n[_DYN_SPAN_ID]=e.spanId,n[_DYN_TRACE_FLAGS]=e[_DYN_TRACE_FLAGS],n[_DYN_CONTEXT]=e[_DYN_CONTEXT])}var BLOB_CORE="*.blob.core.",DfltAjaxCorrelationHeaderExDomains=objFreeze([BLOB_CORE+"windows.net",BLOB_CORE+"chinacloudapi.cn",BLOB_CORE+"cloudapi.de",BLOB_CORE+"usgovcloudapi.net"]),_internalExcludeEndpoints=[/https:\/\/[^\/]*(\.pipe\.aria|aria\.pipe|events\.data|collector\.azure)\.[^\/]+\/(OneCollector\/1|Collector\/3)\.0/i],_defaultConfig=objFreeze(((_a={})[_DYN_MAX_AJAX_CALLS_PER_V5]=500,_a[_DYN_DISABLE_AJAX_TRACKIN7]=!1,_a[_DYN_DISABLE_FETCH_TRACKI9]=!1,_a[_DYN_EXCLUDE_REQUEST_FROM6]=undefined,_a.disableCorrelationHeaders=!1,_a.distributedTracingMode=1,_a.correlationHeaderExcludedDomains=DfltAjaxCorrelationHeaderExDomains,_a.correlationHeaderDomains=undefined,_a.correlationHeaderExcludePatterns=undefined,_a.appId=undefined,_a.enableCorsCorrelation=!1,_a[_DYN_ENABLE_REQUEST_HEADE2]=!1,_a[_DYN_ENABLE_RESPONSE_HEAD10]=!1,_a[_DYN_ENABLE_AJAX_ERROR_ST3]=!1,_a[_DYN_ENABLE_AJAX_PERF_TRA4]=!1,_a.maxAjaxPerfLookupAttempts=3,_a[_DYN_AJAX_PERF_LOOKUP_DEL8]=25,_a.ignoreHeaders=["Authorization","X-API-Key","WWW-Authenticate"],_a.addRequestContext=undefined,_a.addIntEndpoints=!0,_a)),AjaxMonitor=function(n){function B(){var A,g,y,O,C,I,r,m,P,Y,h,L,b,v,U,H,F,x,G,w,j,t,M,k,V,X,K,W,q,$,e=n.call(this)||this;return e.identifier=B.identifier,e.priority=120,dynamicProto(B,e,function(l,o){var _=o[_DYN__ADD_HOOK];function e(){var e=getLocation();$=g=A=!1,y=e&&e.host&&e.host[_DYN_TO_LOWER_CASE](),v=L=Y=P=I=C=!1,F=H=!(U={}),w=G=x=h=m=O=null,t=b=r=0,M=[],k=[],j=createUniqueNamespace("ajaxData"),l._ajaxDataId=j,W=K=X=1,q=V=null}function E(t){var n=!0;return(t||V)&&arrForEach(V,function(e){if(e[_DYN_TO_LOWER_CASE]()===t[_DYN_TO_LOWER_CASE]())return n=!1,-1}),n}function i(e,t,n){_(InstrumentProto(e,t,n))}function N(e,t,n){var r=!1,a=((isString(t)?t:(t||{}).url||"")||"")[_DYN_TO_LOWER_CASE]();if(arrForEach(x,function(e){var t=e;isString(e)&&(t=RegExp(e)),r=r||t.test(a)}),r)return r;var o=_indexOf(a,"?"),_=_indexOf(a,"#");return-1!==(o=-1===o||-1!==_&&_<o?_:o)&&(a=a.substring(0,o)),isNullOrUndefined(e)?isNullOrUndefined(t)||(r="object"==typeof t&&!0===t[DisabledPropertyName]||!!n&&!0===n[DisabledPropertyName]):r=!0===e[DisabledPropertyName]||!0===a[DisabledPropertyName],(r=!(r||!a||!isInternalApplicationInsightsEndpoint(a))||r)?U[a]||(U[a]=1):U[a]&&(r=!0),r}function c(e,t,n){var r=!0,a=g;return isNullOrUndefined(e)||(r=!0===n||!isNullOrUndefined(t)),a&&r}function T(){var e=null;return!(e=l[_DYN_CORE]&&l[_DYN_CORE].getTraceCtx?l[_DYN_CORE].getTraceCtx(!1):e)&&m&&m.telemetryTrace?createDistributedTraceContextFromTrace(m.telemetryTrace):e}function f(r,a){a.xhrMonitoringState[_DYN_STATE_CHANGE_ATTACHE11]=eventOn(r,"readystatechange",function(){var e,o,_;try{r&&4===r.readyState&&c(r,a)&&((_=_getAjaxData(o=r,j))[_DYN_RESPONSE_FINISHED_TI12]=dateTimeUtilsNow(),_[_DYN_STATUS]=o[_DYN_STATUS],u("xmlhttprequest",_,function(){try{var e,t=_[_DYN__CREATE_TRACK_ITEM]("Ajax",C,function(){(t={statusText:o[_DYN_STATUS_TEXT],headerMap:null})[_DYN_CORRELATION_CONTEXT]=s(o),t.type=o.responseType,t[_DYN_RESPONSE_TEXT]=function(e){try{var t=e.responseType;if(""===t||"text"===t)return e[_DYN_RESPONSE_TEXT]}catch(n){}return null}(o),t.response=o.response;var e,n,t;return v&&(e=o[_DYN_GET_ALL_RESPONSE_HEA13]())&&(e=strTrim(e).split(/[\r\n]+/),n={},arrForEach(e,function(e){var e=e.split(": "),t=e.shift(),e=e.join(": ");E(t)&&(n[t]=e)}),t[_DYN_HEADER_MAP]=n),t}),n=void 0;try{G&&(n=G({status:o[_DYN_STATUS],xhr:o}))}catch(a){_throwInternalWarning(l,104,CUSTOM_REQUEST_CONTEXT_ERROR)}t?(n!==undefined&&(t[STR_PROPERTIES]=__assignFn(__assignFn({},t.properties),n)),e=_[_DYN_GET_PART_APROPS](),S(k,l[_DYN_CORE],_,t,null,e)):i(null,{requestSentTime:_[_DYN_REQUEST_SENT_TIME],responseFinishedTime:_[_DYN_RESPONSE_FINISHED_TI12]})}finally{try{var r=(o[AJAX_DATA_CONTAINER]||{i:{}}).i||{};r[j]&&(r[j]=null)}catch(a){}}},function(e){i(e,null)}))}catch(n){var t=dumpObj(n);t&&-1!==_indexOf(t[_DYN_TO_LOWER_CASE](),"c00c023f")||_throwInternalCritical(l,16,ERROR_HEADER+" 'readystatechange' event handler"+ERROR_POSTFIX,((e={})[_DYN_AJAX_DIAGNOSTICS_MES14]=_getFailedAjaxDiagnosticsMessage(r,j),e.exception=t,e))}function i(e,t){t=t||{};t.ajaxDiagnosticsMessage=_getFailedAjaxDiagnosticsMessage(o,j),e&&(t.exception=dumpObj(e)),_throwInternalWarning(l,14,FAILED_TO_CALCULATE_DURATION_ERROR+"ajax call"+ERROR_NOT_SENT,t)}},w)}function s(e){try{var t=e[_DYN_GET_ALL_RESPONSE_HEA13]();if(null!==t&&-1!==_indexOf(t[_DYN_TO_LOWER_CASE](),RequestHeaders[8]))return correlationIdGetCorrelationContext(e.getResponseHeader(RequestHeaders[0]))}catch(n){_throwInternalWarning(l,18,CORRELATION_HEADER_ERROR,((t={})[_DYN_AJAX_DIAGNOSTICS_MES14]=_getFailedAjaxDiagnosticsMessage(e,j),t.exception=dumpObj(n),t))}}function D(e,t){var n;t[_DYN_REQUEST_URL]&&h&&L&&(n=getPerformance())&&isFunction(n.mark)&&(e=h+e+"#"+ ++_markCount,n.mark(e),(e=n.getEntriesByName(e))&&1===e[_DYN_LENGTH]&&(t[_DYN_PERF_MARK]=e[0]))}function u(o,_,i,s){var c=_[_DYN_PERF_MARK],u=getPerformance(),l=X,E=K,N=_[_DYN_REQUEST_URL],T=0;!function f(){try{if(u&&c){T++;for(var e=null,t=u.getEntries(),n=t[_DYN_LENGTH]-1;0<=n;n--){var r=t[n];if(r){if("resource"===r.entryType)r.initiatorType!==o||-1===_indexOf(r.name,N)&&-1===_indexOf(N,r.name)||(e=r);else if("mark"===r.entryType&&r.name===c.name){_[_DYN_PERF_TIMING]=e;break}if(r[_DYN_START_TIME]<c[_DYN_START_TIME]-1e3)break}}}!c||_[_DYN_PERF_TIMING]||l<=T||!1===_["async"]?(c&&isFunction(u.clearMarks)&&u.clearMarks(c.name),_.perfAttempts=T,i()):scheduleTimeout(f,E)}catch(a){s(a)}}()}function d(e){var t="";try{isNullOrUndefined(e)||(t+="(url: '".concat("string"==typeof e?e:e.url,"')"))}catch(n){_throwInternalCritical(l,15,"Failed to grab failed fetch diagnostics message",{exception:dumpObj(n)})}return t}function p(e,r,a,o,_,i){function s(e,t,n){n=n||{};n.fetchDiagnosticsMessage=d(a),t&&(n.exception=dumpObj(t)),_throwInternalWarning(l,e,FAILED_TO_CALCULATE_DURATION_ERROR+"fetch call"+ERROR_NOT_SENT,n)}_&&(_[_DYN_RESPONSE_FINISHED_TI12]=dateTimeUtilsNow(),_[_DYN_STATUS]=r,u(STR_FETCH,_,function(){var e,t=_[_DYN__CREATE_TRACK_ITEM]("Fetch",C,i);try{G&&(e=G({status:r,request:a,response:o}))}catch(n){_throwInternalWarning(l,104,CUSTOM_REQUEST_CONTEXT_ERROR)}t?(e!==undefined&&(t[STR_PROPERTIES]=__assignFn(__assignFn({},t.properties),e)),e=_[_DYN_GET_PART_APROPS](),S(k,l[_DYN_CORE],_,t,null,e)):s(14,null,{requestSentTime:_[_DYN_REQUEST_SENT_TIME],responseFinishedTime:_[_DYN_RESPONSE_FINISHED_TI12]})},function(e){s(18,e,null)}))}function R(e){if(e&&e[_DYN_HEADERS])try{return correlationIdGetCorrelationContext(e[_DYN_HEADERS].get(RequestHeaders[0]))}catch(t){_throwInternalWarning(l,18,CORRELATION_HEADER_ERROR,{fetchDiagnosticsMessage:d(e),exception:dumpObj(t)})}}function S(e,t,n,r,a,o){var _=!0;(_=0<e[_DYN_LENGTH]?_processDependencyContainer(t,e,{item:r,properties:a,sysProperties:o,context:n?n[_DYN_CONTEXT]:null,aborted:!!n&&!!n[_DYN_ABORTED]},"initializer"):_)&&l[_DYN_TRACK_DEPENDENCY_DAT1](r,a,o)}e(),l.initialize=function(e,t,n,r){var a,u;l.isInitialized()||(o.initialize(e,t,n,r),w=mergeEvtNamespace(createUniqueNamespace("ajax"),t&&t.evtNamespace&&t.evtNamespace()),l[_DYN__ADD_HOOK](onConfigChange(e,function(e){e=createProcessTelemetryContext(null,e.cfg,l[_DYN_CORE]);O=e.getExtCfg(B.identifier,_defaultConfig),W=O.distributedTracingMode,C=O[_DYN_ENABLE_REQUEST_HEADE2],I=O[_DYN_ENABLE_AJAX_ERROR_ST3],L=O[_DYN_ENABLE_AJAX_PERF_TRA4],b=O[_DYN_MAX_AJAX_CALLS_PER_V5],x=[].concat(O[_DYN_EXCLUDE_REQUEST_FROM6]||[],!1!==O.addIntEndpoints?_internalExcludeEndpoints:[]),G=O.addRequestContext,Y=0===W||1===W,P=1===W||2===W,L&&(h=j),H=!!O[_DYN_DISABLE_AJAX_TRACKIN7],X=O.maxAjaxPerfLookupAttempts,K=O[_DYN_AJAX_PERF_LOOKUP_DEL8],V=O.ignoreHeaders,q=O.appId})),_supportsAjaxMonitoring(l,j)&&l[_DYN__ADD_HOOK](onConfigChange(O,function(){H=!!O[_DYN_DISABLE_AJAX_TRACKIN7],C=O[_DYN_ENABLE_REQUEST_HEADE2],H||g||(i(XMLHttpRequest,"open",{ns:w,req:function(e,t,n,r){var a,o,_,i,s;H||(e=e.inst,a=_getAjaxData(e,j),!N(e,n)&&c(e,a,!0)&&(a&&a.xhrMonitoringState.openDone||(i=e,t=t,n=n,r=r,s=(o=T())&&o[_DYN_GET_TRACE_ID]()||generateW3CId(),_=strSubstr(generateW3CId(),0,16),(s=(i=(i=i[AJAX_DATA_CONTAINER]=i[AJAX_DATA_CONTAINER]||{xh:[],i:{}}).i=i.i||{})[j]=i[j]||new ajaxRecord(s,_,l[strDiagLog](),null==(i=l.core)?void 0:i.getTraceCtx()))[_DYN_TRACE_FLAGS]=o&&o[_DYN_GET_TRACE_FLAGS](),s[_DYN_METHOD]=t,s[_DYN_REQUEST_URL]=n,s.xhrMonitoringState.openDone=!0,s[_DYN_REQUEST_HEADERS]={},s["async"]=r,s[_DYN_ERROR_STATUS_TEXT]=I,a=s),f(e,a)))},hkErr:_createErrorCallbackFunc(l,15,ERROR_HEADER+".open"+ERROR_POSTFIX)}),i(XMLHttpRequest,"send",{ns:w,req:function(e,t){var n;H||c(e=e.inst,n=_getAjaxData(e,j))&&!n.xhrMonitoringState.sendDone&&(D("xhr",n),n[_DYN_REQUEST_SENT_TIME]=dateTimeUtilsNow(),l[_DYN_INCLUDE_CORRELATION_0](n,undefined,undefined,e),n.xhrMonitoringState.sendDone=!0)},hkErr:_createErrorCallbackFunc(l,17,ERROR_HEADER+ERROR_POSTFIX)}),i(XMLHttpRequest,"abort",{ns:w,req:function(e){H||c(e=e.inst,e=_getAjaxData(e,j))&&!e.xhrMonitoringState.abortDone&&(e[_DYN_ABORTED]=1,e.xhrMonitoringState.abortDone=!0)},hkErr:_createErrorCallbackFunc(l,13,ERROR_HEADER+".abort"+ERROR_POSTFIX)}),i(XMLHttpRequest,"setRequestHeader",{ns:w,req:function(e,t,n){var r;H||(e=e.inst,(r=_getAjaxData(e,j))&&c(e,r)&&(_addSharedXhrHeaders(e,t,n),C&&E(t)&&(r[_DYN_REQUEST_HEADERS][t]=n)))},hkErr:_createErrorCallbackFunc(l,71,ERROR_HEADER+".setRequestHeader"+ERROR_POSTFIX)}),g=!0)})),(n=_supportsFetch())&&(a=getGlobal(),u=n.polyfill,l[_DYN__ADD_HOOK](onConfigChange(O,function(){F=!!O[_DYN_DISABLE_FETCH_TRACKI9],v=O[_DYN_ENABLE_RESPONSE_HEAD10],F||A?u&&!$&&(_(InstrumentFunc(a,STR_FETCH,{ns:w,req:function(e,t,n){N(null,t,n)}})),$=!0):(_(InstrumentFunc(a,STR_FETCH,{ns:w,req:function(e,t,n){var r,a,o,_,i,s,c;F||!A||N(null,t,n)||u&&g||(r=e.ctx(),a=t,o=n,_=(s=T())&&s[_DYN_GET_TRACE_ID]()||generateW3CId(),i=strSubstr(generateW3CId(),0,16),(i=new ajaxRecord(_,i,l[strDiagLog](),null==(_=l.core)?void 0:_.getTraceCtx()))[_DYN_TRACE_FLAGS]=s&&s[_DYN_GET_TRACE_FLAGS](),i[_DYN_REQUEST_SENT_TIME]=dateTimeUtilsNow(),i[_DYN_ERROR_STATUS_TEXT]=I,""===(_=a instanceof Request?(a||{}).url||"":a)&&(s=getLocation())&&s.href&&(_=strSplit(s.href,"#")[0]),i[_DYN_REQUEST_URL]=_,s="GET",o&&o[_DYN_METHOD]?s=o[_DYN_METHOD]:a&&a instanceof Request&&(s=a[_DYN_METHOD]),i[_DYN_METHOD]=s,c={},C&&new Headers((o?o[_DYN_HEADERS]:0)||a instanceof Request&&a[_DYN_HEADERS]||{}).forEach(function(e,t){E(t)&&(c[t]=e)}),i[_DYN_REQUEST_HEADERS]=c,D(STR_FETCH,i),_=i,(s=l[_DYN_INCLUDE_CORRELATION_0](_,t,n))!==n&&e.set(1,s),r.data=_)},rsp:function(e,n){var r;F||(r=e.ctx().data)&&(e.rslt=e.rslt.then(function(t){return p(0,(t||{})[_DYN_STATUS],n,t,r,function(){(e={statusText:(t||{})[_DYN_STATUS_TEXT],headerMap:null})[_DYN_CORRELATION_CONTEXT]=R(t);var n,e;return v&&t&&(n={},t.headers.forEach(function(e,t){E(t)&&(n[t]=e)}),e[_DYN_HEADER_MAP]=n),e}),t})["catch"](function(e){throw p(0,0,n,null,r,null),e}))},hkErr:_createErrorCallbackFunc(l,15,"Failed to monitor Window.fetch"+ERROR_POSTFIX)},!0,isWebWorker())),A=!0)})),u&&(a[STR_FETCH].polyfill=u)),(r=l[_DYN_CORE].getPlugin(PropertiesPluginIdentifier))&&(m=r.plugin[_DYN_CONTEXT]))},l._doTeardown=function(){e()},l.trackDependencyData=function(e,t){S(k,l[_DYN_CORE],null,e,t)},l[_DYN_INCLUDE_CORRELATION_0]=function(e,t,n,r){var a,o,_,i,s=l._currentWindowHost||y;return _processDependencyListeners(M,l[_DYN_CORE],e,r,t,n),t||""===t?(correlationIdCanIncludeCorrelationHeader(O,e[_DYN_GET_ABSOLUTE_URL](),s)&&(n=n||{},t=new Headers(n[_DYN_HEADERS]||t instanceof Request&&t[_DYN_HEADERS]||{}),Y&&(a="|"+e[_DYN_TRACE_ID]+"."+e[_DYN_SPAN_ID],t.set(RequestHeaders[3],a),C&&(e[_DYN_REQUEST_HEADERS][RequestHeaders[3]]=a)),(o=q||m&&m.appId())&&(t.set(RequestHeaders[0],RequestHeaders[2]+o),C&&(e[_DYN_REQUEST_HEADERS][RequestHeaders[0]]=RequestHeaders[2]+o)),P&&(isNullOrUndefined(_=e[_DYN_TRACE_FLAGS])&&(_=1),i=formatTraceParent(createTraceParent(e[_DYN_TRACE_ID],e[_DYN_SPAN_ID],_)),t.set(RequestHeaders[4],i),C&&(e[_DYN_REQUEST_HEADERS][RequestHeaders[4]]=i)),n[_DYN_HEADERS]=t),n):r?(correlationIdCanIncludeCorrelationHeader(O,e[_DYN_GET_ABSOLUTE_URL](),s)&&(Y&&(_isHeaderSet(r,RequestHeaders[3])?_throwInternalWarning(l,71,"Unable to set ["+RequestHeaders[3]+"] as it has already been set by another instance"):(a="|"+e[_DYN_TRACE_ID]+"."+e[_DYN_SPAN_ID],r[_DYN_SET_REQUEST_HEADER](RequestHeaders[3],a),C&&(e[_DYN_REQUEST_HEADERS][RequestHeaders[3]]=a))),(o=q||m&&m.appId())&&(_isHeaderSet(r,RequestHeaders[0])?_throwInternalWarning(l,71,"Unable to set ["+RequestHeaders[0]+"] as it has already been set by another instance"):(r[_DYN_SET_REQUEST_HEADER](RequestHeaders[0],RequestHeaders[2]+o),C&&(e[_DYN_REQUEST_HEADERS][RequestHeaders[0]]=RequestHeaders[2]+o))),P&&(isNullOrUndefined(_=e[_DYN_TRACE_FLAGS])&&(_=1),_isHeaderSet(r,RequestHeaders[4])?_throwInternalWarning(l,71,"Unable to set ["+RequestHeaders[4]+"] as it has already been set by another instance"):(i=formatTraceParent(createTraceParent(e[_DYN_TRACE_ID],e[_DYN_SPAN_ID],_)),r[_DYN_SET_REQUEST_HEADER](RequestHeaders[4],i),C&&(e[_DYN_REQUEST_HEADERS][RequestHeaders[4]]=i)))),r):undefined},l[_DYN_TRACK_DEPENDENCY_DAT1]=function(e,t,n){-1===b||r<b?(2!==W&&1!==W||"string"!=typeof e.id||"."===e.id[e.id[_DYN_LENGTH]-1]||(e.id+="."),isNullOrUndefined(e[_DYN_START_TIME])&&(e[_DYN_START_TIME]=new Date),e=createTelemetryItem(e,RemoteDependencyData.dataType,RemoteDependencyData.envelopeType,l[strDiagLog](),t,n),l[_DYN_CORE].track(e)):r===b&&_throwInternalCritical(l,55,"Maximum ajax per page view limit reached, ajax monitoring is paused until the next trackPageView(). In order to increase the limit set the maxAjaxCallsPerView configuration parameter.",!0),++r},l.addDependencyListener=function(e){return _addHandler(M,t++,e)},l.addDependencyInitializer=function(e){return _addHandler(k,t++,e)}}),e}return __extendsFn(B,n),B.prototype.processTelemetry=function(e,t){this.processNext(e,t)},B.prototype.addDependencyInitializer=function(e){return null},B.identifier="AjaxDependencyPlugin",B}(BaseTelemetryPlugin);exports.AjaxPlugin=AjaxMonitor,exports.DfltAjaxCorrelationHeaderExDomains=DfltAjaxCorrelationHeaderExDomains,exports.ajaxRecord=ajaxRecord;
//# sourceMappingURL=applicationinsights-dependencies-js.cjs.min.js.map
